package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"reflect"
	"xorm.io/xorm"
)

type AppreciationFlowDb struct {
	Db  *xorm.Engine `json:"db"`
	Uid int          `json:"uid"`
}

func (appreciationFlowDb *AppreciationFlowDb) Set(db *xorm.Engine, uid int) { // set方法
	appreciationFlowDb.Db = db
	appreciationFlowDb.Uid = uid
}

func (appreciationFlowDb *AppreciationFlowDb) GetAppreciationFlow(id int) (m *model.AppreciationFlow, err error) {
	m = new(model.AppreciationFlow)
	has, err := appreciationFlowDb.Db.Where("id =?", id).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (appreciationFlowDb *AppreciationFlowDb) FindAppreciationFlowById(ids interface{}) (*[]model.AppreciationFlow, error) {
	var m []model.AppreciationFlow
	if err := appreciationFlowDb.Db.In("id", ids).Desc("id").Find(&m); err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}

func (appreciationFlowDb *AppreciationFlowDb) FindAppreciationFlow(limit, start int) (*[]model.AppreciationFlow, error) {
	var m []model.AppreciationFlow
	if limit == 0 || start == 0 {
		if err := appreciationFlowDb.Db.Where("uid =?", appreciationFlowDb.Uid).Asc("id").Find(&m); err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
	} else {
		if err := appreciationFlowDb.Db.Where("uid =?", appreciationFlowDb.Uid).Asc("id").Limit(limit, start).Find(m); err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
	}
	return &m, nil
}

func (appreciationFlowDb *AppreciationFlowDb) AppreciationFlowInsert(m *model.AppreciationFlow) (int64, error) {
	_, err := appreciationFlowDb.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (appreciationFlowDb *AppreciationFlowDb) AppreciationFlowUpdate(m *model.AppreciationFlow, columns ...string) (int64, error) {
	affected, err := appreciationFlowDb.Db.Where("id =?", m.Id).Cols(columns...).Update(m)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (appreciationFlowDb *AppreciationFlowDb) AppreciationFlowDelete(id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return appreciationFlowDb.Db.In("id", id).Delete(model.AppreciationFlow{})
	} else {
		return appreciationFlowDb.Db.Where("id = ?", id).Delete(model.AppreciationFlow{})
	}
}
