package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectBlockGreenChainCustomUserAirdrops 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `BlockGreenChainCustomUserAirdropFindByParams` 方法
func BatchSelectBlockGreenChainCustomUserAirdrops(Db *xorm.Engine, params map[string]interface{}) (*[]model.BlockGreenChainCustomUserAirdrop, error) {
	var BlockGreenChainCustomUserAirdropData []model.BlockGreenChainCustomUserAirdrop
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&BlockGreenChainCustomUserAirdropData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &BlockGreenChainCustomUserAirdropData, nil
}

// BlockGreenChainCustomUserAirdropInsert 插入单条数据
func BlockGreenChainCustomUserAirdropInsert(Db *xorm.Engine, BlockGreenChainCustomUserAirdrop *model.BlockGreenChainCustomUserAirdrop) (int64, error) {
	_, err := Db.InsertOne(BlockGreenChainCustomUserAirdrop)
	if err != nil {
		return 0, err
	}
	return BlockGreenChainCustomUserAirdrop.Id, nil
}

// BatchAddBlockGreenChainCustomUserAirdrops 批量新增数据
func BatchAddBlockGreenChainCustomUserAirdrops(Db *xorm.Engine, BlockGreenChainCustomUserAirdropData []*model.BlockGreenChainCustomUserAirdrop) (int64, error) {
	affected, err := Db.Insert(BlockGreenChainCustomUserAirdropData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetBlockGreenChainCustomUserAirdropCount(Db *xorm.Engine) int {
	var BlockGreenChainCustomUserAirdrop model.BlockGreenChainCustomUserAirdrop
	session := Db.Where("")
	count, err := session.Count(&BlockGreenChainCustomUserAirdrop)
	if err != nil {
		return 0
	}
	return int(count)
}

// BlockGreenChainCustomUserAirdropDelete 删除记录
func BlockGreenChainCustomUserAirdropDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.BlockGreenChainCustomUserAirdrop{})
	} else {
		return Db.Where("id = ?", id).Delete(model.BlockGreenChainCustomUserAirdrop{})
	}
}

// BlockGreenChainCustomUserAirdropUpdate 更新记录
func BlockGreenChainCustomUserAirdropUpdate(session *xorm.Session, id interface{}, BlockGreenChainCustomUserAirdrop *model.BlockGreenChainCustomUserAirdrop, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(BlockGreenChainCustomUserAirdrop)
	} else {
		affected, err = session.Where("id=?", id).Update(BlockGreenChainCustomUserAirdrop)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// BlockGreenChainCustomUserAirdropGetOneByParams 通过传入的参数查询数据(单条)
func BlockGreenChainCustomUserAirdropGetOneByParams(session *xorm.Session, params map[string]interface{}) (*model.BlockGreenChainCustomUserAirdrop, error) {
	var m model.BlockGreenChainCustomUserAirdrop
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := session.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, errors.New("未查询到相应的 block_star_chain 记录")
	}
	return &m, nil
}

// BlockGreenChainCustomUserAirdropFindByParams 通过传入的参数查询数据(多条)
func BlockGreenChainCustomUserAirdropFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.BlockGreenChainCustomUserAirdrop, error) {
	var m []model.BlockGreenChainCustomUserAirdrop
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func BlockGreenChainCustomUserAirdropFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.BlockGreenChainCustomUserAirdrop, error) {
	var m []model.BlockGreenChainCustomUserAirdrop
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
