package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectBlockGreenChainSettlementRecords 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `BlockGreenChainSettlementRecordsFindByParams` 方法
func BatchSelectBlockGreenChainSettlementRecords(Db *xorm.Engine, params map[string]interface{}) (*[]model.BlockGreenChainSettlementRecords, error) {
	var BlockGreenChainSettlementRecordsData []model.BlockGreenChainSettlementRecords
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&BlockGreenChainSettlementRecordsData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &BlockGreenChainSettlementRecordsData, nil
}

// BlockGreenChainSettlementRecordsInsert 插入单条数据
func BlockGreenChainSettlementRecordsInsert(session *xorm.Session, BlockGreenChainSettlementRecords *model.BlockGreenChainSettlementRecords) (int64, error) {
	_, err := session.InsertOne(BlockGreenChainSettlementRecords)
	if err != nil {
		return 0, err
	}
	return BlockGreenChainSettlementRecords.Id, nil
}

// BatchAddBlockGreenChainSettlementRecords 批量新增数据
func BatchAddBlockGreenChainSettlementRecords(Db *xorm.Engine, BlockGreenChainSettlementRecordsData []*model.BlockGreenChainSettlementRecords) (int64, error) {
	affected, err := Db.Insert(BlockGreenChainSettlementRecordsData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetBlockGreenChainSettlementRecordsCount(Db *xorm.Engine) int {
	var BlockGreenChainSettlementRecords model.BlockGreenChainSettlementRecords
	session := Db.Where("")
	count, err := session.Count(&BlockGreenChainSettlementRecords)
	if err != nil {
		return 0
	}
	return int(count)
}

// BlockGreenChainSettlementRecordsDelete 删除记录
func BlockGreenChainSettlementRecordsDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.BlockGreenChainSettlementRecords{})
	} else {
		return Db.Where("id = ?", id).Delete(model.BlockGreenChainSettlementRecords{})
	}
}

// BlockGreenChainSettlementRecordsUpdate 更新记录
func BlockGreenChainSettlementRecordsUpdate(session *xorm.Session, id interface{}, BlockGreenChainSettlementRecords *model.BlockGreenChainSettlementRecords, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(BlockGreenChainSettlementRecords)
	} else {
		affected, err = session.Where("id=?", id).Update(BlockGreenChainSettlementRecords)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// BlockGreenChainSettlementRecordsGetOneByParams 通过传入的参数查询数据(单条)
func BlockGreenChainSettlementRecordsGetOneByParams(session *xorm.Session, params map[string]interface{}) (*model.BlockGreenChainSettlementRecords, error) {
	var m model.BlockGreenChainSettlementRecords
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := session.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, errors.New("未查询到相应的 block_star_chain 记录")
	}
	return &m, nil
}

// BlockGreenChainSettlementRecordsFindByParams 通过传入的参数查询数据(多条)
func BlockGreenChainSettlementRecordsFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.BlockGreenChainSettlementRecords, error) {
	var m []model.BlockGreenChainSettlementRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func BlockGreenChainSettlementRecordsFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.BlockGreenChainSettlementRecords, error) {
	var m []model.BlockGreenChainSettlementRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
