package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectBlockStarChainRewardRecords 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `BlockStarChainRewardRecordsFindByParams` 方法
func BatchSelectBlockStarChainRewardRecords(Db *xorm.Engine, params map[string]interface{}) (*[]model.BlockStarChainRewardRecords, error) {
	var BlockStarChainRewardRecordsData []model.BlockStarChainRewardRecords
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&BlockStarChainRewardRecordsData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &BlockStarChainRewardRecordsData, nil
}

// BlockStarChainRewardRecordsInsert 插入单条数据
func BlockStarChainRewardRecordsInsert(session *xorm.Session, BlockStarChainRewardRecords *model.BlockStarChainRewardRecords) (int64, error) {
	_, err := session.InsertOne(BlockStarChainRewardRecords)
	if err != nil {
		return 0, err
	}
	return BlockStarChainRewardRecords.Id, nil
}

// BatchAddBlockStarChainRewardRecords 批量新增数据
func BatchAddBlockStarChainRewardRecords(Db *xorm.Engine, BlockStarChainRewardRecordsData []*model.BlockStarChainRewardRecords) (int64, error) {
	affected, err := Db.Insert(BlockStarChainRewardRecordsData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetBlockStarChainRewardRecordsCount(Db *xorm.Engine) int {
	var BlockStarChainRewardRecords model.BlockStarChainRewardRecords
	session := Db.Where("")
	count, err := session.Count(&BlockStarChainRewardRecords)
	if err != nil {
		return 0
	}
	return int(count)
}

// BlockStarChainRewardRecordsDelete 删除记录
func BlockStarChainRewardRecordsDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.BlockStarChainRewardRecords{})
	} else {
		return Db.Where("id = ?", id).Delete(model.BlockStarChainRewardRecords{})
	}
}

// BlockStarChainRewardRecordsUpdate 更新记录
func BlockStarChainRewardRecordsUpdate(session *xorm.Session, id interface{}, BlockStarChainRewardRecords *model.BlockStarChainRewardRecords, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(BlockStarChainRewardRecords)
	} else {
		affected, err = session.Where("id=?", id).Update(BlockStarChainRewardRecords)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// BlockStarChainRewardRecordsGetOneByParams 通过传入的参数查询数据(单条)
func BlockStarChainRewardRecordsGetOneByParams(session *xorm.Session, params map[string]interface{}) (*model.BlockStarChainRewardRecords, error) {
	var m model.BlockStarChainRewardRecords
	var query = fmt.Sprintf("%s =?", params["key"])
	if has, err := session.Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}

// BlockStarChainRewardRecordsFindByParams 通过传入的参数查询数据(多条)
func BlockStarChainRewardRecordsFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.BlockStarChainRewardRecords, error) {
	var m []model.BlockStarChainRewardRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func BlockStarChainRewardRecordsFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.BlockStarChainRewardRecords, error) {
	var m []model.BlockStarChainRewardRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
