package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectBlockStarChainSettlementRecordss 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `BlockStarChainSettlementRecordsFindByParams` 方法
func BatchSelectBlockStarChainSettlementRecordss(Db *xorm.Engine, params map[string]interface{}) (*[]model.BlockStarChainSettlementRecords, error) {
	var BlockStarChainSettlementRecordsData []model.BlockStarChainSettlementRecords
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&BlockStarChainSettlementRecordsData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &BlockStarChainSettlementRecordsData, nil
}

// BlockStarChainSettlementRecordsInsert 插入单条数据
func BlockStarChainSettlementRecordsInsert(session *xorm.Session, BlockStarChainSettlementRecords *model.BlockStarChainSettlementRecords) (int64, error) {
	_, err := session.InsertOne(BlockStarChainSettlementRecords)
	if err != nil {
		return 0, err
	}
	return BlockStarChainSettlementRecords.Id, nil
}

// BatchAddBlockStarChainSettlementRecordss 批量新增数据
func BatchAddBlockStarChainSettlementRecordss(Db *xorm.Engine, BlockStarChainSettlementRecordsData []*model.BlockStarChainSettlementRecords) (int64, error) {
	affected, err := Db.Insert(BlockStarChainSettlementRecordsData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetBlockStarChainSettlementRecordsCount(Db *xorm.Engine) int {
	var BlockStarChainSettlementRecords model.BlockStarChainSettlementRecords
	session := Db.Where("")
	count, err := session.Count(&BlockStarChainSettlementRecords)
	if err != nil {
		return 0
	}
	return int(count)
}

// BlockStarChainSettlementRecordsDelete 删除记录
func BlockStarChainSettlementRecordsDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.BlockStarChainSettlementRecords{})
	} else {
		return Db.Where("id = ?", id).Delete(model.BlockStarChainSettlementRecords{})
	}
}

// BlockStarChainSettlementRecordsUpdate 更新记录
func BlockStarChainSettlementRecordsUpdate(session *xorm.Session, id interface{}, BlockStarChainSettlementRecords *model.BlockStarChainSettlementRecords, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(BlockStarChainSettlementRecords)
	} else {
		affected, err = session.Where("id=?", id).Update(BlockStarChainSettlementRecords)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// BlockStarChainSettlementRecordsGetOneByParams 通过传入的参数查询数据(单条)
func BlockStarChainSettlementRecordsGetOneByParams(session *xorm.Session, params map[string]interface{}) (*model.BlockStarChainSettlementRecords, error) {
	var m model.BlockStarChainSettlementRecords
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := session.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return &m, nil
}

// BlockStarChainSettlementRecordsFindByParams 通过传入的参数查询数据(多条)
func BlockStarChainSettlementRecordsFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.BlockStarChainSettlementRecords, error) {
	var m []model.BlockStarChainSettlementRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func BlockStarChainSettlementRecordsFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.BlockStarChainSettlementRecords, error) {
	var m []model.BlockStarChainSettlementRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
