package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	"errors"
	"time"
	"xorm.io/xorm"
)

//初始化资金池基础设置
func InitCapitalPool(engine *xorm.Engine) error {
	pool := &model.CapitalPoolAgent{
		IsUse:             0,
		IsAuto:            0,
		BonusType:         "1",
		BonusDateType:     1,
		BonusTime:         "",
		BonusLevelType:    1,
		UserLevelGroup:    "",
		CreateAt:          time.Now(),
		UpdateAt:          time.Now(),
		SettleCardinality: "commission",
	}
	addCapitalPool, err := AddCapitalPool(engine, pool)
	if err != nil {
		return err
	}
	if addCapitalPool != 1 {
		return errors.New("插入条数有误！")
	}
	return nil
}

//新增资金池基础设置
func AddCapitalPool(engine *xorm.Engine, pool *model.CapitalPoolAgent) (int64, error) {
	one, err := engine.InsertOne(pool)
	return one, err
}
func AddCapitalPoolSess(sess *xorm.Session, pool *model.NewCapitalPool) (int64, error) {
	one, err := sess.InsertOne(pool)
	return one, err
}
func AddCapitalPoolNew(eg *xorm.Engine, pool *model.NewCapitalPool) (int64, error) {
	one, err := eg.InsertOne(pool)
	return one, err
}

//编辑资金池基础设置
func UpdateCapitalPool(engine *xorm.Engine, pool *model.CapitalPoolAgent) (int64, error) {
	session := engine.NewSession()
	defer session.Close()
	err := session.Begin()
	if err != nil {
		return 0, err
	}
	update, err := session.ID(pool.Id).AllCols().Update(pool)
	if err != nil {
		session.Rollback()
		return 0, err
	}
	session.Commit()
	return update, err
}
func InitNewCapitalPool(engine *xorm.Engine) error {
	pool := &model.NewCapitalPool{
		IsUse:             0,
		IsAuto:            0,
		BonusType:         "1",
		BonusDateType:     1,
		BonusTime:         "",
		BonusLevelType:    1,
		UserLevelGroup:    "",
		CreateAt:          time.Now(),
		UpdateAt:          time.Now(),
		SettleCardinality: "commission",
	}
	addCapitalPool, err := AddCapitalPoolNew(engine, pool)
	if err != nil {
		return err
	}
	if addCapitalPool != 1 {
		return errors.New("插入条数有误！")
	}
	return nil
}
func InitNewCapitalPoolSess(sess *xorm.Session) error {
	pool := &model.NewCapitalPool{
		IsUse:             0,
		IsAuto:            0,
		BonusType:         "1",
		BonusDateType:     1,
		BonusTime:         "",
		BonusLevelType:    1,
		UserLevelGroup:    "",
		CreateAt:          time.Now(),
		UpdateAt:          time.Now(),
		SettleCardinality: "commission",
	}
	addCapitalPool, err := AddCapitalPoolSess(sess, pool)
	if err != nil {
		return err
	}
	if addCapitalPool != 1 {
		return errors.New("插入条数有误！")
	}
	return nil
}

//获取资金池基础设置
func GetCapitalPool(engine *xorm.Engine) (pool model.CapitalPoolAgent, err error) {
	get, err := engine.Where("1 = 1").Get(&pool)
	if err != nil {
		return model.CapitalPoolAgent{}, err
	}

	if !get {
		err := InitCapitalPool(engine)
		if err != nil {
			return model.CapitalPoolAgent{}, err
		}
		capitalPool, err := GetCapitalPool(engine)
		if err != nil {
			return model.CapitalPoolAgent{}, err
		}
		if capitalPool.SettleCardinality == "" {
			capitalPool.SettleCardinality = "commission"
		}
		return capitalPool, err
	} else {
		if pool.SettleCardinality == "" {
			pool.SettleCardinality = "commission"
		}
	}
	return
}
func GetNewCapitalPool(engine *xorm.Engine) (pool model.NewCapitalPool, err error) {
	get, err := engine.Where("1 = 1").Get(&pool)
	if err != nil {
		return model.NewCapitalPool{}, err
	}

	if !get {
		err := InitNewCapitalPool(engine)
		if err != nil {
			return model.NewCapitalPool{}, err
		}
		capitalPool, err := GetNewCapitalPool(engine)
		if err != nil {
			return model.NewCapitalPool{}, err
		}
		if capitalPool.SettleCardinality == "" {
			capitalPool.SettleCardinality = "commission"
		}
		return capitalPool, err
	} else {
		if pool.SettleCardinality == "" {
			pool.SettleCardinality = "commission"
		}
	}
	return
}
func GetNewCapitalPoolSess(sess *xorm.Session) (pool model.NewCapitalPool, err error) {
	get, err := sess.Where("1 = 1").Get(&pool)
	if err != nil {
		return model.NewCapitalPool{}, err
	}

	if !get {
		err := InitNewCapitalPoolSess(sess)
		if err != nil {
			return model.NewCapitalPool{}, err
		}
		capitalPool, err := GetNewCapitalPoolSess(sess)
		if err != nil {
			return model.NewCapitalPool{}, err
		}
		if capitalPool.SettleCardinality == "" {
			capitalPool.SettleCardinality = "commission"
		}
		return capitalPool, err
	} else {
		if pool.SettleCardinality == "" {
			pool.SettleCardinality = "commission"
		}
	}
	return
}
