package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectIntegralReleaseInterpositionUserAmounts 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `IntegralReleaseInterpositionUserAmountFindByParams` 方法
func BatchSelectIntegralReleaseInterpositionUserAmounts(Db *xorm.Engine, params map[string]interface{}) (*[]model.IntegralReleaseInterpositionUserAmount, error) {
	var IntegralReleaseInterpositionUserAmountData []model.IntegralReleaseInterpositionUserAmount
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&IntegralReleaseInterpositionUserAmountData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &IntegralReleaseInterpositionUserAmountData, nil
}

// IntegralReleaseInterpositionUserAmountInsert 插入单条数据
func IntegralReleaseInterpositionUserAmountInsert(session *xorm.Session, IntegralReleaseInterpositionUserAmount *model.IntegralReleaseInterpositionUserAmount) (int, error) {
	_, err := session.InsertOne(IntegralReleaseInterpositionUserAmount)
	if err != nil {
		return 0, err
	}
	return IntegralReleaseInterpositionUserAmount.Id, nil
}

// BatchAddIntegralReleaseInterpositionUserAmounts 批量新增数据
func BatchAddIntegralReleaseInterpositionUserAmounts(Db *xorm.Engine, IntegralReleaseInterpositionUserAmountData []*model.IntegralReleaseInterpositionUserAmount) (int64, error) {
	affected, err := Db.Insert(IntegralReleaseInterpositionUserAmountData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetIntegralReleaseInterpositionUserAmountCount(Db *xorm.Engine) int {
	var IntegralReleaseInterpositionUserAmount model.IntegralReleaseInterpositionUserAmount
	session := Db.Where("")
	count, err := session.Count(&IntegralReleaseInterpositionUserAmount)
	if err != nil {
		return 0
	}
	return int(count)
}

// IntegralReleaseInterpositionUserAmountDelete 删除记录
func IntegralReleaseInterpositionUserAmountDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.IntegralReleaseInterpositionUserAmount{})
	} else {
		return Db.Where("id = ?", id).Delete(model.IntegralReleaseInterpositionUserAmount{})
	}
}

// IntegralReleaseInterpositionUserAmountUpdate 更新记录
func IntegralReleaseInterpositionUserAmountUpdate(session *xorm.Session, id interface{}, IntegralReleaseInterpositionUserAmount *model.IntegralReleaseInterpositionUserAmount, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(IntegralReleaseInterpositionUserAmount)
	} else {
		affected, err = session.Where("id=?", id).Update(IntegralReleaseInterpositionUserAmount)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// IntegralReleaseInterpositionUserAmountGetOneByParams 通过传入的参数查询数据(单条)
func IntegralReleaseInterpositionUserAmountGetOneByParams(session *xorm.Session, coinId int, params map[string]interface{}) (*model.IntegralReleaseInterpositionUserAmount, error) {
	var m model.IntegralReleaseInterpositionUserAmount
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := session.Where(query, params["value"]).And("coin_id =?", coinId).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, errors.New("not found")
	}
	return &m, nil
}

// IntegralReleaseInterpositionUserAmountFindByParams 通过传入的参数查询数据(多条)
func IntegralReleaseInterpositionUserAmountFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.IntegralReleaseInterpositionUserAmount, error) {
	var m []model.IntegralReleaseInterpositionUserAmount
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func IntegralReleaseInterpositionUserAmountFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.IntegralReleaseInterpositionUserAmount, error) {
	var m []model.IntegralReleaseInterpositionUserAmount
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
