package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectIntegralReleaseUserWithOrds 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `IntegralReleaseUserWithOrdFindByParams` 方法
func BatchSelectIntegralReleaseUserWithOrds(Db *xorm.Engine, params map[string]interface{}) (*[]model.IntegralReleaseUserWithOrd, error) {
	var IntegralReleaseUserWithOrdData []model.IntegralReleaseUserWithOrd
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&IntegralReleaseUserWithOrdData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &IntegralReleaseUserWithOrdData, nil
}

// IntegralReleaseUserWithOrdInsert 插入单条数据
func IntegralReleaseUserWithOrdInsert(Db *xorm.Engine, IntegralReleaseUserWithOrd *model.IntegralReleaseUserWithOrd) (int, error) {
	_, err := Db.InsertOne(IntegralReleaseUserWithOrd)
	if err != nil {
		return 0, err
	}
	return IntegralReleaseUserWithOrd.Id, nil
}
func IntegralReleaseUserWithOrdInsertSess(sess *xorm.Session, IntegralReleaseUserWithOrd *model.IntegralReleaseUserWithOrd) (int, error) {
	_, err := sess.Insert(IntegralReleaseUserWithOrd)
	if err != nil {
		return 0, err
	}
	return IntegralReleaseUserWithOrd.Id, nil
}

// BatchAddIntegralReleaseUserWithOrds 批量新增数据
func BatchAddIntegralReleaseUserWithOrds(Db *xorm.Engine, IntegralReleaseUserWithOrdData []*model.IntegralReleaseUserWithOrd) (int64, error) {
	affected, err := Db.Insert(IntegralReleaseUserWithOrdData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetIntegralReleaseUserWithOrdCount(Db *xorm.Engine) int {
	var IntegralReleaseUserWithOrd model.IntegralReleaseUserWithOrd
	session := Db.Where("")
	count, err := session.Count(&IntegralReleaseUserWithOrd)
	if err != nil {
		return 0
	}
	return int(count)
}

// IntegralReleaseUserWithOrdDelete 删除记录
func IntegralReleaseUserWithOrdDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.IntegralReleaseUserWithOrd{})
	} else {
		return Db.Where("id = ?", id).Delete(model.IntegralReleaseUserWithOrd{})
	}
}

// IntegralReleaseUserWithOrdUpdate 更新记录
func IntegralReleaseUserWithOrdUpdate(session *xorm.Session, id interface{}, IntegralReleaseUserWithOrd *model.IntegralReleaseUserWithOrd, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(IntegralReleaseUserWithOrd)
	} else {
		affected, err = session.Where("id=?", id).Update(IntegralReleaseUserWithOrd)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// IntegralReleaseUserWithOrdGetOneByParams 通过传入的参数查询数据(单条)
func IntegralReleaseUserWithOrdGetOneByParams(session *xorm.Session, params map[string]interface{}) (*model.IntegralReleaseUserWithOrd, error) {
	var m model.IntegralReleaseUserWithOrd
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := session.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, errors.New("未查询到相应的 block_star_chain 记录")
	}
	return &m, nil
}
func IntegralReleaseUserWithOrdByUid(session *xorm.Session, uid, pvd int) (*model.IntegralReleaseUserWithOrd, error) {
	var m model.IntegralReleaseUserWithOrd
	has, err := session.Where("uid=? and pvd=?", uid, pvd).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, errors.New("未查询到相应的 block_star_chain 记录")
	}
	return &m, nil
}

// IntegralReleaseUserWithOrdFindByParams 通过传入的参数查询数据(多条)
func IntegralReleaseUserWithOrdFindByParams(session *xorm.Session, params map[string]interface{}) (*[]model.IntegralReleaseUserWithOrd, error) {
	var m []model.IntegralReleaseUserWithOrd
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := session.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := session.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := session.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func IntegralReleaseUserWithOrdFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.IntegralReleaseUserWithOrd, error) {
	var m []model.IntegralReleaseUserWithOrd
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
