package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectIntegralReleaseUserWithOrdFlows 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `IntegralReleaseUserWithOrdFlowFindByParams` 方法
func BatchSelectIntegralReleaseUserWithOrdFlows(Db *xorm.Engine, params map[string]interface{}) (*[]model.IntegralReleaseUserWithOrdFlow, error) {
	var IntegralReleaseUserWithOrdFlowData []model.IntegralReleaseUserWithOrdFlow
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&IntegralReleaseUserWithOrdFlowData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &IntegralReleaseUserWithOrdFlowData, nil
}

// IntegralReleaseUserWithOrdFlowInsert 插入单条数据
func IntegralReleaseUserWithOrdFlowInsert(session *xorm.Session, IntegralReleaseUserWithOrdFlow *model.IntegralReleaseUserWithOrdFlow) (int, error) {
	_, err := session.InsertOne(IntegralReleaseUserWithOrdFlow)
	if err != nil {
		return 0, err
	}
	return IntegralReleaseUserWithOrdFlow.Id, nil
}

// BatchAddIntegralReleaseUserWithOrdFlows 批量新增数据
func BatchAddIntegralReleaseUserWithOrdFlows(Db *xorm.Engine, IntegralReleaseUserWithOrdFlowData []*model.IntegralReleaseUserWithOrdFlow) (int64, error) {
	affected, err := Db.Insert(IntegralReleaseUserWithOrdFlowData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetIntegralReleaseUserWithOrdFlowCount(Db *xorm.Engine) int {
	var IntegralReleaseUserWithOrdFlow model.IntegralReleaseUserWithOrdFlow
	session := Db.Where("")
	count, err := session.Count(&IntegralReleaseUserWithOrdFlow)
	if err != nil {
		return 0
	}
	return int(count)
}

// IntegralReleaseUserWithOrdFlowDelete 删除记录
func IntegralReleaseUserWithOrdFlowDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.IntegralReleaseUserWithOrdFlow{})
	} else {
		return Db.Where("id = ?", id).Delete(model.IntegralReleaseUserWithOrdFlow{})
	}
}

// IntegralReleaseUserWithOrdFlowUpdate 更新记录
func IntegralReleaseUserWithOrdFlowUpdate(session *xorm.Session, id interface{}, IntegralReleaseUserWithOrdFlow *model.IntegralReleaseUserWithOrdFlow, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(IntegralReleaseUserWithOrdFlow)
	} else {
		affected, err = session.Where("id=?", id).Update(IntegralReleaseUserWithOrdFlow)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// IntegralReleaseUserWithOrdFlowGetOneByParams 通过传入的参数查询数据(单条)
func IntegralReleaseUserWithOrdFlowGetOneByParams(session *xorm.Session, params map[string]interface{}) (*model.IntegralReleaseUserWithOrdFlow, error) {
	var m model.IntegralReleaseUserWithOrdFlow
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := session.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, errors.New("未查询到相应的 block_star_chain 记录")
	}
	return &m, nil
}

// IntegralReleaseUserWithOrdFlowFindByParams 通过传入的参数查询数据(多条)
func IntegralReleaseUserWithOrdFlowFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.IntegralReleaseUserWithOrdFlow, error) {
	var m []model.IntegralReleaseUserWithOrdFlow
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func IntegralReleaseUserWithOrdFlowFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.IntegralReleaseUserWithOrdFlow, error) {
	var m []model.IntegralReleaseUserWithOrdFlow
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
