package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectNiuBeiCoinUserWithOrds 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `NiuBeiCoinUserWithOrdFindByParams` 方法
func BatchSelectNiuBeiCoinUserWithOrds(Db *xorm.Engine, params map[string]interface{}) (*[]model.NiuBeiCoinUserWithOrd, error) {
	var NiuBeiCoinUserWithOrdData []model.NiuBeiCoinUserWithOrd
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&NiuBeiCoinUserWithOrdData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &NiuBeiCoinUserWithOrdData, nil
}

// NiuBeiCoinUserWithOrdInsert 插入单条数据
func NiuBeiCoinUserWithOrdInsert(Db *xorm.Engine, NiuBeiCoinUserWithOrd *model.NiuBeiCoinUserWithOrd) (int, error) {
	_, err := Db.InsertOne(NiuBeiCoinUserWithOrd)
	if err != nil {
		return 0, err
	}
	return NiuBeiCoinUserWithOrd.Id, nil
}

// BatchAddNiuBeiCoinUserWithOrds 批量新增数据
func BatchAddNiuBeiCoinUserWithOrds(Db *xorm.Engine, NiuBeiCoinUserWithOrdData []*model.NiuBeiCoinUserWithOrd) (int64, error) {
	affected, err := Db.Insert(NiuBeiCoinUserWithOrdData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetNiuBeiCoinUserWithOrdCount(Db *xorm.Engine) int {
	var NiuBeiCoinUserWithOrd model.NiuBeiCoinUserWithOrd
	session := Db.Where("")
	count, err := session.Count(&NiuBeiCoinUserWithOrd)
	if err != nil {
		return 0
	}
	return int(count)
}

// NiuBeiCoinUserWithOrdDelete 删除记录
func NiuBeiCoinUserWithOrdDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.NiuBeiCoinUserWithOrd{})
	} else {
		return Db.Where("id = ?", id).Delete(model.NiuBeiCoinUserWithOrd{})
	}
}

// NiuBeiCoinUserWithOrdUpdate 更新记录
func NiuBeiCoinUserWithOrdUpdate(session *xorm.Session, id interface{}, NiuBeiCoinUserWithOrd *model.NiuBeiCoinUserWithOrd, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(NiuBeiCoinUserWithOrd)
	} else {
		affected, err = session.Where("id=?", id).Update(NiuBeiCoinUserWithOrd)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// NiuBeiCoinUserWithOrdGetOneByParams 通过传入的参数查询数据(单条)
func NiuBeiCoinUserWithOrdGetOneByParams(session *xorm.Session, params map[string]interface{}) (*model.NiuBeiCoinUserWithOrd, error) {
	var m model.NiuBeiCoinUserWithOrd
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := session.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, errors.New("未查询到相应的 block_star_chain 记录")
	}
	return &m, nil
}

// NiuBeiCoinUserWithOrdFindByParams 通过传入的参数查询数据(多条)
func NiuBeiCoinUserWithOrdFindByParams(session *xorm.Session, params map[string]interface{}) (*[]model.NiuBeiCoinUserWithOrd, error) {
	var m []model.NiuBeiCoinUserWithOrd
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := session.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := session.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := session.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func NiuBeiCoinUserWithOrdFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.NiuBeiCoinUserWithOrd, error) {
	var m []model.NiuBeiCoinUserWithOrd
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
