package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectNiuBeiCoinUserWithOrdFlows 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `NiuBeiCoinUserWithOrdFlowFindByParams` 方法
func BatchSelectNiuBeiCoinUserWithOrdFlows(Db *xorm.Engine, params map[string]interface{}) (*[]model.NiuBeiCoinUserWithOrdFlow, error) {
	var NiuBeiCoinUserWithOrdFlowData []model.NiuBeiCoinUserWithOrdFlow
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&NiuBeiCoinUserWithOrdFlowData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &NiuBeiCoinUserWithOrdFlowData, nil
}

// NiuBeiCoinUserWithOrdFlowInsert 插入单条数据
func NiuBeiCoinUserWithOrdFlowInsert(session *xorm.Session, NiuBeiCoinUserWithOrdFlow *model.NiuBeiCoinUserWithOrdFlow) (int, error) {
	_, err := session.InsertOne(NiuBeiCoinUserWithOrdFlow)
	if err != nil {
		return 0, err
	}
	return NiuBeiCoinUserWithOrdFlow.Id, nil
}

// BatchAddNiuBeiCoinUserWithOrdFlows 批量新增数据
func BatchAddNiuBeiCoinUserWithOrdFlows(Db *xorm.Engine, NiuBeiCoinUserWithOrdFlowData []*model.NiuBeiCoinUserWithOrdFlow) (int64, error) {
	affected, err := Db.Insert(NiuBeiCoinUserWithOrdFlowData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetNiuBeiCoinUserWithOrdFlowCount(Db *xorm.Engine) int {
	var NiuBeiCoinUserWithOrdFlow model.NiuBeiCoinUserWithOrdFlow
	session := Db.Where("")
	count, err := session.Count(&NiuBeiCoinUserWithOrdFlow)
	if err != nil {
		return 0
	}
	return int(count)
}

// NiuBeiCoinUserWithOrdFlowDelete 删除记录
func NiuBeiCoinUserWithOrdFlowDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.NiuBeiCoinUserWithOrdFlow{})
	} else {
		return Db.Where("id = ?", id).Delete(model.NiuBeiCoinUserWithOrdFlow{})
	}
}

// NiuBeiCoinUserWithOrdFlowUpdate 更新记录
func NiuBeiCoinUserWithOrdFlowUpdate(session *xorm.Session, id interface{}, NiuBeiCoinUserWithOrdFlow *model.NiuBeiCoinUserWithOrdFlow, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(NiuBeiCoinUserWithOrdFlow)
	} else {
		affected, err = session.Where("id=?", id).Update(NiuBeiCoinUserWithOrdFlow)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// NiuBeiCoinUserWithOrdFlowGetOneByParams 通过传入的参数查询数据(单条)
func NiuBeiCoinUserWithOrdFlowGetOneByParams(session *xorm.Session, params map[string]interface{}) (*model.NiuBeiCoinUserWithOrdFlow, error) {
	var m model.NiuBeiCoinUserWithOrdFlow
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := session.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, errors.New("未查询到相应的 block_star_chain 记录")
	}
	return &m, nil
}

// NiuBeiCoinUserWithOrdFlowFindByParams 通过传入的参数查询数据(多条)
func NiuBeiCoinUserWithOrdFlowFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.NiuBeiCoinUserWithOrdFlow, error) {
	var m []model.NiuBeiCoinUserWithOrdFlow
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func NiuBeiCoinUserWithOrdFlowFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.NiuBeiCoinUserWithOrdFlow, error) {
	var m []model.NiuBeiCoinUserWithOrdFlow
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
