package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectOneCirclesGreenEnergyPrices 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `OneCirclesGreenEnergyPriceFindByParams` 方法
func BatchSelectOneCirclesGreenEnergyPrices(Db *xorm.Engine, params map[string]interface{}) (*[]model.OneCirclesGreenEnergyPrice, error) {
	var OneCirclesGreenEnergyPriceData []model.OneCirclesGreenEnergyPrice
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&OneCirclesGreenEnergyPriceData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &OneCirclesGreenEnergyPriceData, nil
}

// OneCirclesGreenEnergyPriceInsert 插入单条数据
func OneCirclesGreenEnergyPriceInsert(Db *xorm.Engine, OneCirclesGreenEnergyPrice *model.OneCirclesGreenEnergyPrice) (int64, error) {
	_, err := Db.InsertOne(OneCirclesGreenEnergyPrice)
	if err != nil {
		return 0, err
	}
	return OneCirclesGreenEnergyPrice.Id, nil
}

// OneCirclesGreenEnergyPriceInsertBySession 插入单条数据
func OneCirclesGreenEnergyPriceInsertBySession(session *xorm.Session, OneCirclesGreenEnergyPrice *model.OneCirclesGreenEnergyPrice) (int64, error) {
	_, err := session.InsertOne(OneCirclesGreenEnergyPrice)
	if err != nil {
		return 0, err
	}
	return OneCirclesGreenEnergyPrice.Id, nil
}

// BatchAddOneCirclesGreenEnergyPrices 批量新增数据
func BatchAddOneCirclesGreenEnergyPrices(Db *xorm.Engine, OneCirclesGreenEnergyPriceData []*model.OneCirclesGreenEnergyPrice) (int64, error) {
	affected, err := Db.Insert(OneCirclesGreenEnergyPriceData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetOneCirclesGreenEnergyPriceCount(Db *xorm.Engine) int {
	var OneCirclesGreenEnergyPrice model.OneCirclesGreenEnergyPrice
	session := Db.Where("")
	count, err := session.Count(&OneCirclesGreenEnergyPrice)
	if err != nil {
		return 0
	}
	return int(count)
}

// OneCirclesGreenEnergyPriceDelete 删除记录
func OneCirclesGreenEnergyPriceDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.OneCirclesGreenEnergyPrice{})
	} else {
		return Db.Where("id = ?", id).Delete(model.OneCirclesGreenEnergyPrice{})
	}
}

// OneCirclesGreenEnergyPriceUpdate 更新记录
func OneCirclesGreenEnergyPriceUpdate(session *xorm.Session, id interface{}, OneCirclesGreenEnergyPrice *model.OneCirclesGreenEnergyPrice, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(OneCirclesGreenEnergyPrice)
	} else {
		affected, err = session.Where("id=?", id).Update(OneCirclesGreenEnergyPrice)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// OneCirclesGreenEnergyPriceGetOneByParamsBySession 通过传入的参数查询数据(单条)
func OneCirclesGreenEnergyPriceGetOneByParamsBySession(session *xorm.Session, date, hour string) (*model.OneCirclesGreenEnergyPrice, error) {
	var m model.OneCirclesGreenEnergyPrice
	has, err := session.Where("date =? and hour =?", date, hour).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return &m, nil
}

// OneCirclesGreenEnergyPriceGetOneByParams 通过传入的参数查询数据(单条)
func OneCirclesGreenEnergyPriceGetOneByParams(Db *xorm.Engine, params map[string]interface{}) (*model.OneCirclesGreenEnergyPrice, error) {
	var m model.OneCirclesGreenEnergyPrice
	var query = fmt.Sprintf("%s =?", params["key"])
	if has, err := Db.Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}

// OneCirclesGreenEnergyPriceFindByParams 通过传入的参数查询数据(多条)
func OneCirclesGreenEnergyPriceFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.OneCirclesGreenEnergyPrice, error) {
	var m []model.OneCirclesGreenEnergyPrice
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func OneCirclesGreenEnergyPriceFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.OneCirclesGreenEnergyPrice, error) {
	var m []model.OneCirclesGreenEnergyPrice
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
