package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// OneCirclesPublicPlatoonBasicSettingInsert 插入单条数据
func OneCirclesPublicPlatoonBasicSettingInsert(Db *xorm.Engine, OneCirclesPublicPlatoonBasicSetting *model.OneCirclesPublicPlatoonBasicSetting) (int, error) {
	_, err := Db.InsertOne(OneCirclesPublicPlatoonBasicSetting)
	if err != nil {
		return 0, err
	}
	return OneCirclesPublicPlatoonBasicSetting.Id, nil
}

// BatchAddOneCirclesPublicPlatoonBasicSettings 批量新增数据
func BatchAddOneCirclesPublicPlatoonBasicSettings(Db *xorm.Engine, OneCirclesPublicPlatoonBasicSettingData []*model.OneCirclesPublicPlatoonBasicSetting) (int64, error) {
	affected, err := Db.Insert(OneCirclesPublicPlatoonBasicSettingData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetOneCirclesPublicPlatoonBasicSettingCount(Db *xorm.Engine) int {
	var OneCirclesPublicPlatoonBasicSetting model.OneCirclesPublicPlatoonBasicSetting
	session := Db.Where("")
	count, err := session.Count(&OneCirclesPublicPlatoonBasicSetting)
	if err != nil {
		return 0
	}
	return int(count)
}

// OneCirclesPublicPlatoonBasicSettingDelete 删除记录
func OneCirclesPublicPlatoonBasicSettingDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.OneCirclesPublicPlatoonBasicSetting{})
	} else {
		return Db.Where("id = ?", id).Delete(model.OneCirclesPublicPlatoonBasicSetting{})
	}
}

// OneCirclesPublicPlatoonBasicSettingUpdate 更新记录
func OneCirclesPublicPlatoonBasicSettingUpdate(Db *xorm.Engine, id interface{}, OneCirclesPublicPlatoonBasicSetting *model.OneCirclesPublicPlatoonBasicSetting, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = Db.Where("id=?", id).Cols(forceColums...).Update(OneCirclesPublicPlatoonBasicSetting)
	} else {
		affected, err = Db.Where("id=?", id).Update(OneCirclesPublicPlatoonBasicSetting)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// OneCirclesPublicPlatoonBasicSettingGetOneByParams 通过传入的参数查询数据(单条)
func OneCirclesPublicPlatoonBasicSettingGetOneByParams(Db *xorm.Engine, params map[string]interface{}) (*model.OneCirclesPublicPlatoonBasicSetting, error) {
	var m model.OneCirclesPublicPlatoonBasicSetting
	var query = fmt.Sprintf("%s =?", params["key"])
	if has, err := Db.Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}

// OneCirclesPublicPlatoonBasicSettingFindByParams 通过传入的参数查询数据(多条)
func OneCirclesPublicPlatoonBasicSettingFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.OneCirclesPublicPlatoonBasicSetting, error) {
	var m []model.OneCirclesPublicPlatoonBasicSetting
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
