package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectOneCirclesStarLevelDividendsRecordss 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `OneCirclesStarLevelDividendsRecordsFindByParams` 方法
func BatchSelectOneCirclesStarLevelDividendsRecordss(Db *xorm.Engine, params map[string]interface{}) (*[]model.OneCirclesStarLevelDividendsRecords, error) {
	var OneCirclesStarLevelDividendsRecordsData []model.OneCirclesStarLevelDividendsRecords
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&OneCirclesStarLevelDividendsRecordsData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &OneCirclesStarLevelDividendsRecordsData, nil
}

// OneCirclesStarLevelDividendsRecordsInsert 插入单条数据
func OneCirclesStarLevelDividendsRecordsInsertBySession(session *xorm.Session, OneCirclesStarLevelDividendsRecords *model.OneCirclesStarLevelDividendsRecords) (int64, error) {
	_, err := session.InsertOne(OneCirclesStarLevelDividendsRecords)
	if err != nil {
		return 0, err
	}
	return OneCirclesStarLevelDividendsRecords.Id, nil
}

// BatchAddOneCirclesStarLevelDividendsRecordss 批量新增数据
func BatchAddOneCirclesStarLevelDividendsRecordss(Db *xorm.Engine, OneCirclesStarLevelDividendsRecordsData []*model.OneCirclesStarLevelDividendsRecords) (int64, error) {
	affected, err := Db.Insert(OneCirclesStarLevelDividendsRecordsData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetOneCirclesStarLevelDividendsRecordsCount(Db *xorm.Engine) int {
	var OneCirclesStarLevelDividendsRecords model.OneCirclesStarLevelDividendsRecords
	session := Db.Where("")
	count, err := session.Count(&OneCirclesStarLevelDividendsRecords)
	if err != nil {
		return 0
	}
	return int(count)
}

// OneCirclesStarLevelDividendsRecordsDelete 删除记录
func OneCirclesStarLevelDividendsRecordsDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.OneCirclesStarLevelDividendsRecords{})
	} else {
		return Db.Where("id = ?", id).Delete(model.OneCirclesStarLevelDividendsRecords{})
	}
}

// OneCirclesStarLevelDividendsRecordsUpdate 更新记录
func OneCirclesStarLevelDividendsRecordsUpdate(Db *xorm.Engine, id interface{}, OneCirclesStarLevelDividendsRecords *model.OneCirclesStarLevelDividendsRecords, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = Db.Where("id=?", id).Cols(forceColums...).Update(OneCirclesStarLevelDividendsRecords)
	} else {
		affected, err = Db.Where("id=?", id).Update(OneCirclesStarLevelDividendsRecords)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func OneCirclesStarLevelDividendsRecordsUpdateBySession(session *xorm.Session, id interface{}, OneCirclesStarLevelDividendsRecords *model.OneCirclesStarLevelDividendsRecords, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(OneCirclesStarLevelDividendsRecords)
	} else {
		affected, err = session.Where("id=?", id).Update(OneCirclesStarLevelDividendsRecords)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// OneCirclesStarLevelDividendsRecordsGetOneByParamsBySession 通过传入的参数查询数据(单条)
func OneCirclesStarLevelDividendsRecordsGetOneByParamsBySession(session *xorm.Session, params map[string]interface{}) (*model.OneCirclesStarLevelDividendsRecords, error) {
	var m model.OneCirclesStarLevelDividendsRecords
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := session.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return &m, nil
}

// OneCirclesStarLevelDividendsRecordsGetOneByParams 通过传入的参数查询数据(单条)
func OneCirclesStarLevelDividendsRecordsGetOneByParams(Db *xorm.Engine, params map[string]interface{}) (*model.OneCirclesStarLevelDividendsRecords, error) {
	var m model.OneCirclesStarLevelDividendsRecords
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := Db.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if !has {
		return nil, nil
	}
	return &m, nil
}

// OneCirclesStarLevelDividendsRecordsFindByParams 通过传入的参数查询数据(多条)
func OneCirclesStarLevelDividendsRecordsFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.OneCirclesStarLevelDividendsRecords, error) {
	var m []model.OneCirclesStarLevelDividendsRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func OneCirclesStarLevelDividendsRecordsFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.OneCirclesStarLevelDividendsRecords, error) {
	var m []model.OneCirclesStarLevelDividendsRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
