package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectOneCirclesUserWatchRecordss 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `OneCirclesUserWatchRecordsFindByParams` 方法
func BatchSelectOneCirclesUserWatchRecordss(Db *xorm.Engine, params map[string]interface{}) (*[]model.OneCirclesUserWatchRecords, error) {
	var OneCirclesUserWatchRecordsData []model.OneCirclesUserWatchRecords
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&OneCirclesUserWatchRecordsData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &OneCirclesUserWatchRecordsData, nil
}

// OneCirclesUserWatchRecordsInsert 插入单条数据
func OneCirclesUserWatchRecordsInsert(Db *xorm.Engine, OneCirclesUserWatchRecords *model.OneCirclesUserWatchRecords) (int64, error) {
	_, err := Db.InsertOne(OneCirclesUserWatchRecords)
	if err != nil {
		return 0, err
	}
	return OneCirclesUserWatchRecords.Id, nil
}

// BatchAddOneCirclesUserWatchRecordss 批量新增数据
func BatchAddOneCirclesUserWatchRecordss(Db *xorm.Engine, OneCirclesUserWatchRecordsData []*model.OneCirclesUserWatchRecords) (int64, error) {
	affected, err := Db.Insert(OneCirclesUserWatchRecordsData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetOneCirclesUserWatchRecordsCount(Db *xorm.Engine) int {
	var OneCirclesUserWatchRecords model.OneCirclesUserWatchRecords
	session := Db.Where("")
	count, err := session.Count(&OneCirclesUserWatchRecords)
	if err != nil {
		return 0
	}
	return int(count)
}

// OneCirclesUserWatchRecordsDelete 删除记录
func OneCirclesUserWatchRecordsDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.OneCirclesUserWatchRecords{})
	} else {
		return Db.Where("id = ?", id).Delete(model.OneCirclesUserWatchRecords{})
	}
}

// OneCirclesUserWatchRecordsUpdate 更新记录
func OneCirclesUserWatchRecordsUpdate(Db *xorm.Engine, id interface{}, OneCirclesUserWatchRecords *model.OneCirclesUserWatchRecords, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = Db.Where("id=?", id).Cols(forceColums...).Update(OneCirclesUserWatchRecords)
	} else {
		affected, err = Db.Where("id=?", id).Update(OneCirclesUserWatchRecords)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func OneCirclesUserWatchRecordsUpdateBySession(session *xorm.Session, id interface{}, OneCirclesUserWatchRecords *model.OneCirclesUserWatchRecords, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(OneCirclesUserWatchRecords)
	} else {
		affected, err = session.Where("id=?", id).Update(OneCirclesUserWatchRecords)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// OneCirclesUserWatchRecordsGetOneByParamsBySession 通过传入的参数查询数据(单条)
func OneCirclesUserWatchRecordsGetOneByParamsBySession(session *xorm.Session, params map[string]interface{}) (*model.OneCirclesUserWatchRecords, error) {
	var m model.OneCirclesUserWatchRecords
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := session.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, errors.New("未查询到相应的 block_star_chain 记录")
	}
	return &m, nil
}

// OneCirclesUserWatchRecordsGetOneByParams 通过传入的参数查询数据(单条)
func OneCirclesUserWatchRecordsGetOneByParams(Db *xorm.Engine, params map[string]interface{}) (*model.OneCirclesUserWatchRecords, error) {
	var m model.OneCirclesUserWatchRecords
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := Db.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if !has {
		return nil, nil
	}
	return &m, nil
}

// OneCirclesUserWatchRecordsFindByParams 通过传入的参数查询数据(多条)
func OneCirclesUserWatchRecordsFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.OneCirclesUserWatchRecords, error) {
	var m []model.OneCirclesUserWatchRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func OneCirclesUserWatchRecordsFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.OneCirclesUserWatchRecords, error) {
	var m []model.OneCirclesUserWatchRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
