package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"xorm.io/xorm"
)

// UserFindByID is find user byid
func UserFindByID(Db *xorm.Engine, id interface{}) (*model.User, error) {
	var m model.User
	if has, err := Db.Where("uid = ?", id).
		Get(&m); err != nil || has == false {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &m, nil
}
func UserProfileFindByID(Db *xorm.Engine, id interface{}) (*model.UserProfile, error) {
	var m model.UserProfile
	if has, err := Db.Where("uid = ?", id).
		Get(&m); err != nil || has == false {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &m, nil
}
func DbsUserFindByIdsSess(sess *xorm.Session, uid []int) (*[]model.User, error) {
	var users []model.User
	if err := sess.In("uid", uid).Find(&users); err != nil {
		return nil, err
	}
	if len(users) == 0 {
		return nil, nil
	}
	return &users, nil
}

func UserProfileFindByIDWithSession(sess *xorm.Session, id interface{}) (*model.UserProfile, error) {
	var m model.UserProfile
	if has, err := sess.Where("uid = ?", id).
		Get(&m); err != nil || has == false {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &m, nil
}
func UserProfileUpdateWithSession(session *xorm.Session, uid interface{}, userProfile *model.UserProfile, forceCols ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceCols != nil {
		affected, err = session.Where("uid=?", uid).Cols(forceCols...).Update(userProfile)
	} else {
		affected, err = session.Where("uid=?", uid).Update(userProfile)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}
