package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectUserPublicPlatoonAmounts 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `UserPublicPlatoonAmountFindByParams` 方法
func BatchSelectUserPublicPlatoonAmounts(Db *xorm.Engine, params map[string]interface{}) (*[]model.UserPublicPlatoonAmount, error) {
	var UserPublicPlatoonAmountData []model.UserPublicPlatoonAmount
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&UserPublicPlatoonAmountData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &UserPublicPlatoonAmountData, nil
}

// UserPublicPlatoonAmountInsert 插入单条数据
func UserPublicPlatoonAmountInsert(Db *xorm.Engine, UserPublicPlatoonAmount *model.UserPublicPlatoonAmount) (int64, error) {
	_, err := Db.InsertOne(UserPublicPlatoonAmount)
	if err != nil {
		return 0, err
	}
	return UserPublicPlatoonAmount.Id, nil
}

// BatchAddUserPublicPlatoonAmounts 批量新增数据
func BatchAddUserPublicPlatoonAmounts(Db *xorm.Engine, UserPublicPlatoonAmountData []*model.UserPublicPlatoonAmount) (int64, error) {
	affected, err := Db.Insert(UserPublicPlatoonAmountData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetUserPublicPlatoonAmountCount(Db *xorm.Engine) int {
	var UserPublicPlatoonAmount model.UserPublicPlatoonAmount
	session := Db.Where("")
	count, err := session.Count(&UserPublicPlatoonAmount)
	if err != nil {
		return 0
	}
	return int(count)
}

// UserPublicPlatoonAmountDelete 删除记录
func UserPublicPlatoonAmountDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.UserPublicPlatoonAmount{})
	} else {
		return Db.Where("id = ?", id).Delete(model.UserPublicPlatoonAmount{})
	}
}

// UserPublicPlatoonAmountUpdate 更新记录
func UserPublicPlatoonAmountUpdate(session *xorm.Session, id interface{}, UserPublicPlatoonAmount *model.UserPublicPlatoonAmount, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(UserPublicPlatoonAmount)
	} else {
		affected, err = session.Where("id=?", id).Update(UserPublicPlatoonAmount)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// UserPublicPlatoonAmountGetOneByParams 通过传入的参数查询数据(单条)
func UserPublicPlatoonAmountGetOneByParams(Db *xorm.Engine, params map[string]interface{}) (*model.UserPublicPlatoonAmount, error) {
	var m model.UserPublicPlatoonAmount
	var query = fmt.Sprintf("%s =?", params["key"])
	if has, err := Db.Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}

// UserPublicPlatoonAmountFindByParams 通过传入的参数查询数据(多条)
func UserPublicPlatoonAmountFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.UserPublicPlatoonAmount, error) {
	var m []model.UserPublicPlatoonAmount
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
