package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectUserPublicPlatoonSettings 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `UserPublicPlatoonSettingFindByParams` 方法
func BatchSelectUserPublicPlatoonSettings(Db *xorm.Engine, params map[string]interface{}) (*[]model.UserPublicPlatoonSetting, error) {
	var UserPublicPlatoonSettingData []model.UserPublicPlatoonSetting
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&UserPublicPlatoonSettingData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &UserPublicPlatoonSettingData, nil
}

// UserPublicPlatoonSettingInsert 插入单条数据
func UserPublicPlatoonSettingInsert(Db *xorm.Engine, UserPublicPlatoonSetting *model.UserPublicPlatoonSetting) (int, error) {
	_, err := Db.InsertOne(UserPublicPlatoonSetting)
	if err != nil {
		return 0, err
	}
	return UserPublicPlatoonSetting.Id, nil
}

// BatchAddUserPublicPlatoonSettings 批量新增数据
func BatchAddUserPublicPlatoonSettings(Db *xorm.Engine, UserPublicPlatoonSettingData []*model.UserPublicPlatoonSetting) (int64, error) {
	affected, err := Db.Insert(UserPublicPlatoonSettingData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetUserPublicPlatoonSettingCount(Db *xorm.Engine) int {
	var UserPublicPlatoonSetting model.UserPublicPlatoonSetting
	session := Db.Where("")
	count, err := session.Count(&UserPublicPlatoonSetting)
	if err != nil {
		return 0
	}
	return int(count)
}

// UserPublicPlatoonSettingDelete 删除记录
func UserPublicPlatoonSettingDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.UserPublicPlatoonSetting{})
	} else {
		return Db.Where("id = ?", id).Delete(model.UserPublicPlatoonSetting{})
	}
}

// UserPublicPlatoonSettingUpdate 更新记录
func UserPublicPlatoonSettingUpdate(Db *xorm.Engine, id interface{}, UserPublicPlatoonSetting *model.UserPublicPlatoonSetting, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = Db.Where("id=?", id).Cols(forceColums...).Update(UserPublicPlatoonSetting)
	} else {
		affected, err = Db.Where("id=?", id).Update(UserPublicPlatoonSetting)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// UserPublicPlatoonSettingGetOneByParams 通过传入的参数查询数据(单条)
func UserPublicPlatoonSettingGetOneByParams(Db *xorm.Engine, params map[string]interface{}) (*model.UserPublicPlatoonSetting, error) {
	var m model.UserPublicPlatoonSetting
	var query = fmt.Sprintf("%s =?", params["key"])
	if has, err := Db.Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}

// UserPublicPlatoonSettingFindByParams 通过传入的参数查询数据(多条)
func UserPublicPlatoonSettingFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.UserPublicPlatoonSetting, error) {
	var m []model.UserPublicPlatoonSetting
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
