package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectUserPublicPlatoonSettlementRecordss 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `UserPublicPlatoonSettlementRecordsFindByParams` 方法
func BatchSelectUserPublicPlatoonSettlementRecordss(Db *xorm.Engine, params map[string]interface{}) (*[]model.UserPublicPlatoonSettlementRecords, error) {
	var UserPublicPlatoonSettlementRecordsData []model.UserPublicPlatoonSettlementRecords
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&UserPublicPlatoonSettlementRecordsData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &UserPublicPlatoonSettlementRecordsData, nil
}

// UserPublicPlatoonSettlementRecordsInsert 插入单条数据
func UserPublicPlatoonSettlementRecordsInsert(Db *xorm.Engine, UserPublicPlatoonSettlementRecords *model.UserPublicPlatoonSettlementRecords) (int64, error) {
	_, err := Db.InsertOne(UserPublicPlatoonSettlementRecords)
	if err != nil {
		return 0, err
	}
	return UserPublicPlatoonSettlementRecords.Id, nil
}

// BatchAddUserPublicPlatoonSettlementRecordss 批量新增数据
func BatchAddUserPublicPlatoonSettlementRecordss(session *xorm.Session, UserPublicPlatoonSettlementRecordsData []*model.UserPublicPlatoonSettlementRecords) (int64, error) {
	affected, err := session.Insert(UserPublicPlatoonSettlementRecordsData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetUserPublicPlatoonSettlementRecordsCount(Db *xorm.Engine) int {
	var UserPublicPlatoonSettlementRecords model.UserPublicPlatoonSettlementRecords
	session := Db.Where("")
	count, err := session.Count(&UserPublicPlatoonSettlementRecords)
	if err != nil {
		return 0
	}
	return int(count)
}

// UserPublicPlatoonSettlementRecordsDelete 删除记录
func UserPublicPlatoonSettlementRecordsDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.UserPublicPlatoonSettlementRecords{})
	} else {
		return Db.Where("id = ?", id).Delete(model.UserPublicPlatoonSettlementRecords{})
	}
}

// UserPublicPlatoonSettlementRecordsUpdate 更新记录
func UserPublicPlatoonSettlementRecordsUpdate(Db *xorm.Engine, id interface{}, UserPublicPlatoonSettlementRecords *model.UserPublicPlatoonSettlementRecords, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = Db.Where("id=?", id).Cols(forceColums...).Update(UserPublicPlatoonSettlementRecords)
	} else {
		affected, err = Db.Where("id=?", id).Update(UserPublicPlatoonSettlementRecords)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// UserPublicPlatoonSettlementRecordsGetOneByParams 通过传入的参数查询数据(单条)
func UserPublicPlatoonSettlementRecordsGetOneByParams(Db *xorm.Engine, params map[string]interface{}) (*model.UserPublicPlatoonSettlementRecords, error) {
	var m model.UserPublicPlatoonSettlementRecords
	var query = fmt.Sprintf("%s =?", params["key"])
	if has, err := Db.Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}

// UserPublicPlatoonSettlementRecordsFindByParams 通过传入的参数查询数据(多条)
func UserPublicPlatoonSettlementRecordsFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.UserPublicPlatoonSettlementRecords, error) {
	var m []model.UserPublicPlatoonSettlementRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
