package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectUserPublicPlatoonSystemPunishRecordss 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `UserPublicPlatoonSystemPunishRecordsFindByParams` 方法
func BatchSelectUserPublicPlatoonSystemPunishRecordss(Db *xorm.Engine, params map[string]interface{}) (*[]model.UserPublicPlatoonSystemPunishRecords, error) {
	var UserPublicPlatoonSystemPunishRecordsData []model.UserPublicPlatoonSystemPunishRecords
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&UserPublicPlatoonSystemPunishRecordsData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &UserPublicPlatoonSystemPunishRecordsData, nil
}

// UserPublicPlatoonSystemPunishRecordsInsert 插入单条数据
func UserPublicPlatoonSystemPunishRecordsInsert(session *xorm.Session, UserPublicPlatoonSystemPunishRecords *model.UserPublicPlatoonSystemPunishRecords) (int64, error) {
	_, err := session.InsertOne(UserPublicPlatoonSystemPunishRecords)
	if err != nil {
		return 0, err
	}
	return UserPublicPlatoonSystemPunishRecords.Id, nil
}

// BatchAddUserPublicPlatoonSystemPunishRecords 批量新增数据
func BatchAddUserPublicPlatoonSystemPunishRecords(session *xorm.Session, UserPublicPlatoonSystemPunishRecordsData []*model.UserPublicPlatoonSystemPunishRecords) (int64, error) {
	affected, err := session.Insert(UserPublicPlatoonSystemPunishRecordsData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetUserPublicPlatoonSystemPunishRecordsCount(Db *xorm.Engine) int {
	var UserPublicPlatoonSystemPunishRecords model.UserPublicPlatoonSystemPunishRecords
	session := Db.Where("")
	count, err := session.Count(&UserPublicPlatoonSystemPunishRecords)
	if err != nil {
		return 0
	}
	return int(count)
}

// UserPublicPlatoonSystemPunishRecordsDelete 删除记录
func UserPublicPlatoonSystemPunishRecordsDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.UserPublicPlatoonSystemPunishRecords{})
	} else {
		return Db.Where("id = ?", id).Delete(model.UserPublicPlatoonSystemPunishRecords{})
	}
}

// UserPublicPlatoonSystemPunishRecordsUpdate 更新记录
func UserPublicPlatoonSystemPunishRecordsUpdate(Db *xorm.Engine, id interface{}, UserPublicPlatoonSystemPunishRecords *model.UserPublicPlatoonSystemPunishRecords, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = Db.Where("id=?", id).Cols(forceColums...).Update(UserPublicPlatoonSystemPunishRecords)
	} else {
		affected, err = Db.Where("id=?", id).Update(UserPublicPlatoonSystemPunishRecords)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// UserPublicPlatoonSystemPunishRecordsGetOneByParams 通过传入的参数查询数据(单条)
func UserPublicPlatoonSystemPunishRecordsGetOneByParams(Db *xorm.Engine, params map[string]interface{}) (*model.UserPublicPlatoonSystemPunishRecords, error) {
	var m model.UserPublicPlatoonSystemPunishRecords
	var query = fmt.Sprintf("%s =?", params["key"])
	if has, err := Db.Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}

// UserPublicPlatoonSystemPunishRecordsFindByParams 通过传入的参数查询数据(多条)
func UserPublicPlatoonSystemPunishRecordsFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.UserPublicPlatoonSystemPunishRecords, error) {
	var m []model.UserPublicPlatoonSystemPunishRecords
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
