package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"xorm.io/xorm"
)

func DbsPlanRewardByPvd(eg *xorm.Engine, pvd string) (*model.PlanReward, error) {
	m := &model.PlanReward{}
	if isGet, err := eg.Where("pvd = ?", pvd).Get(m); err != nil || !isGet {
		return nil, zhios_order_relate_logx.Warn(err)
	}

	return m, nil
}

func DbsPlanRewardByPvds(eg *xorm.Engine, pvds ...string) ([]*model.PlanReward, error) {
	var m []*model.PlanReward
	var err error
	if len(pvds) > 0 {
		err = eg.In("pvd", pvds).Find(&m)
	} else {
		err = eg.Find(&m)
	}
	if err != nil {
		return nil, err
	}
	return m, nil
}
