package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"xorm.io/xorm"
)

func DbsUserFindByIds(eg *xorm.Engine, uid []int) (*[]model.User, error) {
	var users []model.User
	if err := eg.In("uid", uid).Asc("level").Find(&users); err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if len(users) == 0 {
		return nil, nil
	}
	return &users, nil
}

func DbsUserFindByUid(eg *xorm.Engine, uid int) (*model.User, error) {
	var data model.User
	get, err := eg.Where("uid =?", uid).Get(&data)
	if get == false || err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &data, nil
}

func DbsUserRelate(eg *xorm.Engine, uid, level int) (*[]model.UserRelate, error) {
	var userRelate []model.UserRelate
	sess := eg.Where("uid = ?", uid)
	if level > 0 {
		sess.And("level<=?", level)
	}
	if err := sess.Asc("level").Find(&userRelate); err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if len(userRelate) == 0 {
		return nil, nil
	}
	return &userRelate, nil
}

func GetUserParentUserRelate(eg *xorm.Engine, uid int) (*model.UserRelate, error) {
	var data model.UserRelate
	get, err := eg.Where("level=1 and uid =?", uid).Get(&data)
	if get == false || err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &data, nil
}

func DbsUserRelateByParentUid(eg *xorm.Engine, uid, level int) (*[]model.UserRelate, error) {
	var userRelate []model.UserRelate
	sess := eg.Where("parent_uid = ?", uid)
	if level > 0 {
		sess.And("level<=?", level)
	}
	if err := sess.Asc("level").Find(&userRelate); err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if len(userRelate) == 0 {
		return nil, nil
	}
	return &userRelate, nil
}

func SumUserRelateByParentUid(eg *xorm.Engine, parentUid string) (total int64, userRelate []*model.UserRelate, err error) {
	total, err = eg.Where("parent_uid = ?", parentUid).And("level = 1").FindAndCount(&userRelate)
	return
}
