package model

type AppreciationFlow struct {
	Id            int64  `json:"id" xorm:"pk autoincr BIGINT(20)"`
	CoinId        int    `json:"coin_id" xorm:"not null default 0 comment('虚拟币id') INT(11)"`
	Uid           int    `json:"uid" xorm:"not null default 0 comment('用户id') INT(11)"`
	Kind          int    `json:"kind" xorm:"not null default 1 comment('流水类型') TINYINT(1)"`
	Value         string `json:"value" xorm:"not null default 0.0000 comment('虚拟币值') DECIMAL(20,4)"`
	BeforeFlowSum string `json:"before_flow_sum" xorm:"not null default 0.0000 comment('变动前-流通资产') DECIMAL(20,4)"`
	AfterFlowSum  string `json:"after_flow_sum" xorm:"not null default 0.0000 comment('变动后-流通资产') DECIMAL(20,4)"`
	BeforeSum     string `json:"before_sum" xorm:"not null default 0.0000 comment('变动前-总资产') DECIMAL(20,4)"`
	AfterSum      string `json:"after_sum" xorm:"not null default 0.0000 comment('变动后-总资产') DECIMAL(20,4)"`
	CreateAt      string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt      string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
