package model

import (
	"time"
)

type BlockGreenChainCustomUserAirdrop struct {
	Id                 int64     `json:"id" xorm:"pk autoincr BIGINT(20)"`
	Uid                int       `json:"uid" xorm:"not null default 0 comment('用户id') INT(11)"`
	AirdropTotalNums   string    `json:"airdrop_total_nums" xorm:"not null default 0.0000 comment('空投总数量') DECIMAL(10,4)"`
	AirdropAlreadyNums string    `json:"airdrop_already_nums" xorm:"not null default 0.0000 comment('已空投数量') DECIMAL(10,4)"`
	AirdropFrequency   int       `json:"airdrop_frequency" xorm:"not null default 0 comment('空投频率(天/次)') INT(11)"`
	AirdropNums        string    `json:"airdrop_nums" xorm:"not null default 0.0000 comment('空投数量(个/次)') DECIMAL(10,4)"`
	AirdropDate        string    `json:"airdrop_date" xorm:"not null default '0000-00' comment('空投日期') CHAR(50)"`
	CreateAt           time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt           time.Time `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
