package model

import (
	"time"
)

type BlockGreenChainSettlementRecords struct {
	Id                         int64     `json:"id" xorm:"pk autoincr BIGINT(20)"`
	CoinId                     int       `json:"coin_id" xorm:"not null comment('虚拟币id') INT(11)"`
	TodayPublishCoin           string    `json:"today_publish_coin" xorm:"not null default 0.0000000000 comment('今日区块币发行总数量') DECIMAL(28,10)"`
	TodayDestroyCoinForSystem  string    `json:"today_destroy_coin_for_system" xorm:"not null default 0.0000000000 comment('今日销毁区块币数量-系统') DECIMAL(28,10)"`
	TodayPublishCoinForConsume string    `json:"today_publish_coin_for_consume" xorm:"not null default 0.0000000000 comment('今日区块币发行数量-消费奖励区') DECIMAL(28,10)"`
	TodayDestroyCoinForConsume string    `json:"today_destroy_coin_for_consume" xorm:"not null default 0.0000000000 comment('今日销毁区块币数量-消费奖励区') DECIMAL(28,10)"`
	TodayPublishCoinForAirdrop string    `json:"today_publish_coin_for_airdrop" xorm:"not null default 0.0000000000 comment('今日区块币发行数量-空投区') DECIMAL(28,10)"`
	TodayDestroyCoinForAirdrop string    `json:"today_destroy_coin_for_airdrop" xorm:"not null default 0.0000000000 comment('今日销毁区块币数量-空投区') DECIMAL(28,10)"`
	Date                       string    `json:"date" xorm:"not null default '' comment('日期(0000-00)') VARCHAR(50)"`
	CreateAt                   time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt                   time.Time `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
