package model

import (
	"time"
)

type BlockStarChainFlow struct {
	Id                       int64     `json:"id" xorm:"pk autoincr BIGINT(20)"`
	CoinId                   int       `json:"coin_id" xorm:"not null comment('虚拟币id') INT(11)"`
	Direction                int       `json:"direction" xorm:"not null default 1 comment('方向:1收入 2支出') TINYINT(255)"`
	Kind                     int       `json:"kind" xorm:"not null default 1 comment('种类(1:系统定时发放 2:系统销毁 3:静态未分配完销毁 4:动态未分配完销毁 4:运营中心未分配完销毁 5:运营中心未分配完销毁 6:打赏销毁 7:打赏未分配完销毁 7:自营拼团抽奖销毁 8:红包转余额销毁 9:转增手续费销毁)') TINYINT(1)"`
	Title                    string    `json:"title" xorm:"not null default '' comment('标题') VARCHAR(255)"`
	Amount                   string    `json:"amount" xorm:"not null comment('变更数量') DECIMAL(28,10)"`
	BeforeTotalNowCoin       string    `json:"before_total_now_coin" xorm:"not null default 0.0000000000 comment('变更前-区块币总量') DECIMAL(28,10)"`
	AfterTotalNowCoin        string    `json:"after_total_now_coin" xorm:"not null default 0.0000000000 comment('变更后-区块币总量') DECIMAL(28,10)"`
	BeforeTotalRemainderCoin string    `json:"before_total_remainder_coin" xorm:"not null default 0.0000000000 comment('变更前-累计区块币剩余总量') DECIMAL(28,10)"`
	AfterTotalRemainderCoin  string    `json:"after_total_remainder_coin" xorm:"not null default 0.0000000000 comment('变更后-累计区块币剩余总量') DECIMAL(28,10)"`
	BeforeTotalPublishCoin   string    `json:"before_total_publish_coin" xorm:"default 0.0000000000 comment('变更前-累计区块币发行总量') DECIMAL(28,10)"`
	AfterTotalPublishCoin    string    `json:"after_total_publish_coin" xorm:"default 0.0000000000 comment('变更后-累计区块币发行总量') DECIMAL(28,10)"`
	BeforeTotalDestroyCoin   string    `json:"before_total_destroy_coin" xorm:"default 0.0000000000 comment('变更前-累计区块币销毁总量') DECIMAL(28,10)"`
	AfterTotalDestroyCoin    string    `json:"after_total_destroy_coin" xorm:"default 0.0000000000 comment('变更后-累计区块币销毁总量') DECIMAL(28,10)"`
	CreateTime               time.Time `json:"create_time" xorm:"default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
}
