package model

import (
	"time"
)

type CapitalPoolAgentOrd struct {
	Id                int       `json:"id" xorm:"not null pk autoincr comment('主键id') INT(11)"`
	Uid               int       `json:"uid" xorm:"not null comment('用户id') INT(11)"`
	Pvd               string    `json:"pvd" xorm:"not null comment('订单渠道：自营，导购，o2o。。。。') VARCHAR(255)"`
	OrdId             int64     `json:"ord_id" xorm:"not null default 0 comment('订单id') BIGINT(20)"`
	Commission        string    `json:"commission" xorm:"not null comment('订单总佣金') DECIMAL(12,6)"`
	Price             string    `json:"price" xorm:"not null comment('付款金额') DECIMAL(12,6)"`
	CommissionType    string    `json:"commission_type" xorm:"not null default '0' comment('佣金类型（CNY，虚拟币1Id，虚拟币2Id）') VARCHAR(100)"`
	CapitalPoolRate   string    `json:"capital_pool_rate" xorm:"not null comment('资金池存入比例') DECIMAL(6,4)"`
	DepositValue      string    `json:"deposit_value" xorm:"not null comment('存入金额') DECIMAL(12,6)"`
	CreateAt          time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateAt          time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
	SettleCardinality string    `json:"settle_cardinality" xorm:"comment('基数') VARCHAR(255)"`
}
