package model

type GreenCoinDoubleChainExchangeRecords struct {
	Id                              int64  `json:"id" xorm:"pk autoincr BIGINT(20)"`
	Uid                             int    `json:"uid" xorm:"not null default 0 comment('兑换用户id') INT(11)"`
	ContributeUid1                  int    `json:"contribute_uid_1" xorm:"contribute_uid_1 not null default 0 comment('第1个贡献用户id') INT(11)"`
	ContributeUid2                  int    `json:"contribute_uid_2" xorm:"contribute_uid_2 not null default 0 comment('第2个贡献用户id') INT(11)"`
	CoinId1                         int    `json:"coin_id_1" xorm:"coin_id_1 not null default 0 comment('coinId_1(作用于绿色积分)') INT(11)"`
	CoinId2                         int    `json:"coin_id_2" xorm:"coin_id_2 not null default 0 comment('coinId_2(作用于贡献积分)') INT(11)"`
	Amount                          string `json:"amount" xorm:"not null default 0.00 comment('兑换金额') DECIMAL(8,2)"`
	BeforeUserCoinAmount            string `json:"before_user_coin_amount" xorm:"not null default 0.00 comment('用户兑换前金额') DECIMAL(8,2)"`
	AfterUserCoinAmount             string `json:"after_user_coin_amount" xorm:"not null default 0.00 comment('用户兑换后金额') DECIMAL(8,2)"`
	BeforeCoinAmountContributeUser1 string `json:"before_coin_amount_contribute_user_1" xorm:"before_coin_amount_contribute_user_1 not null default 0.00 comment('第1个贡献用户兑换前金额') DECIMAL(8,2)"`
	AfterCoinAmountContributeUser1  string `json:"after_coin_amount_contribute_user_1" xorm:"after_coin_amount_contribute_user_1 not null default 0.00 comment('第1个贡献用户兑换后金额') DECIMAL(8,2)"`
	BeforeCoinAmountContributeUser2 string `json:"before_coin_amount_contribute_user_2" xorm:"before_coin_amount_contribute_user_2 not null default 0.00 comment('第2个贡献用户兑换前金额') DECIMAL(8,2)"`
	AfterCoinAmountContributeUser2  string `json:"after_coin_amount_contribute_user_2" xorm:"after_coin_amount_contribute_user_2 not null default 0.00 comment('第2个贡献用户兑换后金额') DECIMAL(8,2)"`
	CreateAt                        string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt                        string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
}
