package model

import (
	"time"
)

type IntegralReleaseBasic struct {
	Id                           int       `json:"id" xorm:"not null pk autoincr comment('主键id') INT(11)"`
	IsUse                        int       `json:"is_use" xorm:"not null default 0 comment('是否开启（否：0；是：1）') TINYINT(1)"`
	Coin1                        int       `json:"coin_1" xorm:"coin_1 not null default 0 comment('coinId_1(类似于红积分)') INT(11)"`
	Coin2                        int       `json:"coin_2" xorm:"coin_2 not null default 0 comment('coinId_2(类似于绿积分)') INT(11)"`
	RegisterGiveCoinNum          string    `json:"register_give_coin_num" xorm:"not null default 0.0000 comment('注册赠送积分数量') DECIMAL(10,4)"`
	SignInReleaseRatio           string    `json:"sign_in_release_ratio" xorm:"not null default 0.0000 comment('签到释放比例') DECIMAL(10,4)"`
	BusinessDiscountSet          string    `json:"business_discount_set" xorm:"not null comment('商家让利释放速度设置') TEXT"`
	AlipayServiceChargeRate      string `json:"alipay_service_charge_rate" xorm:"not null default 0.0000 comment('支付宝手续费比例') DECIMAL(10,4)"`
	TaxRevenueRate               string `json:"tax_revenue_rate" xorm:"not null default 0.0000 comment('税收比例') DECIMAL(10,4)"`
	OperatingExpenseRate         string `json:"operating_expense_rate" xorm:"not null default 0.0000 comment('服务费比例') DECIMAL(10,4)"`
	DistributableCoefficientRate string `json:"distributable_coefficient_rate" xorm:"not null default 0.0000 comment('可分配系数比例') DECIMAL(10,4)"`
	ReleaseDate                  string    `json:"release_date" xorm:"not null default '0000-00-00' comment('释放日期') VARCHAR(50)"`
	Ext                          string    `json:"ext" xorm:"TEXT"`
	CreateAt                     time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateAt                     time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
}
