package model

import (
	"time"
)

type IntegralReleaseInterpositionUserAmount struct {
	Id            int       `json:"id" xorm:"not null pk autoincr comment('主键id') INT(11)"`
	Uid           int       `json:"uid" xorm:"not null default 0 comment('用户uid') INT(11)"`
	OriginalUid   int       `json:"original_uid" xorm:"not null default 0 comment('原始用户uid') INT(11)"`
	CoinId        int       `json:"coin_id" xorm:"not null default 0 comment('虚拟币id(若为0则为 余额)') INT(11)"`
	TotalAmount   string    `json:"total_amount" xorm:"not null default 0.0000 comment('累计金额') DECIMAL(10,4)"`
	WaiteAmount   string    `json:"waite_amount" xorm:"not null default 0.0000 comment('待释放金额') DECIMAL(10,4)"`
	AlreadyAmount string    `json:"already_amount" xorm:"not null default 0.0000 comment('已释放金额') DECIMAL(10,4)"`
	State         int       `json:"state" xorm:"not null default 1 comment('状态(1:正常 2:冻结(停止释放))') TINYINT(3)"`
	Ext           string    `json:"ext" xorm:"TEXT"`
	CreateAt      time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateAt      time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
}
