package model

import (
	"time"
)

type IntegralReleaseInterpositionUserFlow struct {
	Id                  int       `json:"id" xorm:"not null pk autoincr comment('主键id') INT(11)"`
	Uid                 int       `json:"uid" xorm:"not null default 0 comment('用户uid') INT(11)"`
	CoinId              int       `json:"coin_id" xorm:"not null default 0 comment('虚拟币id(若为0则为 余额)') INT(11)"`
	OrdId               string    `json:"ord_id" xorm:"not null default '' comment('订单id') VARCHAR(100)"`
	Kind                int       `json:"kind" xorm:"not null default 1 comment('种类(1:流入 2:流出)') TINYINT(1)"`
	Amount              string    `json:"amount" xorm:"not null default 0.0000 comment('金额') DECIMAL(10,4)"`
	BeforeTotalAmount   string    `json:"before_total_amount" xorm:"not null default 0.0000 comment('累计金额-之前') DECIMAL(10,4)"`
	AfterTotalAmount    string    `json:"after_total_amount" xorm:"not null default 0.0000 comment('累计金额-之后') DECIMAL(10,4)"`
	BeforeAlreadyAmount string    `json:"before_already_amount" xorm:"not null default 0.0000 comment('已释放金额-之前') DECIMAL(10,4)"`
	AfterAlreadyAmount  string    `json:"after_already_amount" xorm:"not null default 0.0000 comment('已释放金额-之后') DECIMAL(10,4)"`
	BeforeWaiteAmount   string    `json:"before_waite_amount" xorm:"not null default 0.0000 comment('待释放金额-之前') DECIMAL(10,4)"`
	AfterWaiteAmount    string    `json:"after_waite_amount" xorm:"not null default 0.0000 comment('待释放金额-之后') DECIMAL(10,4)"`
	Date                string    `json:"date" xorm:"not null default '0000-00-00' comment('释放日期') VARCHAR(50)"`
	CreateAt            time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateAt            time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
}
