package model

import (
	"time"
)

type IntegralReleaseUserWithOrd struct {
	Id                   int       `json:"id" xorm:"not null pk autoincr comment('主键id') INT(11)"`
	Uid                  int       `json:"uid" xorm:"not null default 0 comment('uid') INT(11)"`
	OrdId                string    `json:"ord_id" xorm:"not null default '0' comment('订单号') VARCHAR(100)"`
	Pvd                  int       `json:"pvd" xorm:"not null default 0 comment('平台(0:注册)') TINYINT(3)"`
	TotalRedCoinNum      string    `json:"total_red_coin_num" xorm:"not null default 0.0000 comment('总红积分数量') DECIMAL(10,4)"`
	ReleasedGreenCoinNum string    `json:"released_green_coin_num" xorm:"not null default 0.0000 comment('已释放绿积分数量') DECIMAL(10,4)"`
	OrdDiscountRatio     string    `json:"ord_discount_ratio" xorm:"not null default 0.0000 comment('让利百分比') DECIMAL(10,4)"`
	State                int       `json:"state" xorm:"not null default '1' comment('状态(1:正常 2:异常)') TINYINT(1)"`
	CreateAt             time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateAt             time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
}
