package model

import (
	"time"
)

type IntegralReleaseUserWithOrdFlow struct {
	Id                         int       `json:"id" xorm:"not null pk autoincr comment('主键id') INT(11)"`
	Uid                        int       `json:"uid" xorm:"not null default 0 comment('uid') INT(11)"`
	OrdId                      string    `json:"ord_id" xorm:"not null default '0' comment('订单号') VARCHAR(100)"`
	Pvd                        int       `json:"pvd" xorm:"not null default 0 comment('平台(0:注册)') TINYINT(3)"`
	TotalRedCoinNum            string    `json:"total_red_coin_num" xorm:"not null default 0.0000 comment('总红积分数量') DECIMAL(10,4)"`
	ReleasedGreenCoinNumBefore string    `json:"released_green_coin_num_before" xorm:"not null default 0.0000 comment('已释放绿积分数量-之前') DECIMAL(10,4)"`
	ReleasedGreenCoinNumAfter  string    `json:"released_green_coin_num_after" xorm:"not null default 0.0000 comment('已释放绿积分数量-之后') DECIMAL(10,4)"`
	ReleaseGreenCoinNum        string    `json:"release_green_coin_num" xorm:"not null default 0.0000 comment('释放绿积分数量') DECIMAL(10,4)"`
	ReleaseRateDay             string    `json:"release_rate_day" xorm:"not null default 0.0000 comment('日释放系数') DECIMAL(10,4)"`
	ReleaseDate                string    `json:"release_date" xorm:"not null default '0000-00-00' comment('释放日期') VARCHAR(50)"`
	CreateAt                   time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateAt                   time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
}
