package model

import (
	"time"
)

type NewCapitalPool struct {
	Id                   int       `json:"id" xorm:"not null pk autoincr comment('主键id') INT(11)"`
	IsUse                int       `json:"is_use" xorm:"not null comment('是否开启（否：0；是：1）') TINYINT(1)"`
	IsAuto               int       `json:"is_auto" xorm:"not null default 0 comment('是否自动分红（否：0；是：1）') TINYINT(1)"`
	BonusType            string    `json:"bonus_type" xorm:"not null default '0' comment('分红类型（1佣金，2积分，3区块币）多个以逗号隔开') VARCHAR(255)"`
	BonusDateType        int       `json:"bonus_date_type" xorm:"not null default 0 comment('日期类型（1每天，2固定时间）') TINYINT(1)"`
	BonusTime            string    `json:"bonus_time" xorm:"default '0' comment('分红日期（1,15,30）多个日期已逗号分隔开；ps 只有日期类型是2才是有数据') VARCHAR(255)"`
	BonusLevelType       int       `json:"bonus_level_type" xorm:"not null default 0 comment('用户等级分红类型（1，指定等级，2大于或等于指定等级）') TINYINT(1)"`
	UserLevelGroup       string    `json:"user_level_group" xorm:"not null comment('指定用户等级组json') TEXT"`
	UserGroup            string    `json:"user_group" xorm:"not null comment('指定用户组json') LONGTEXT"`
	OpenSecurities       int       `json:"open_securities" xorm:"not null comment('是否开启分红劵功能') TINYINT(1)"`
	SecuritiesId         string    `json:"securities_id" xorm:"not null default '' comment('虚拟币id') VARCHAR(255)"`
	ExchangeSecuritiesId string    `json:"exchange_securities_id" xorm:"comment('兑换分红券虚拟币id') VARCHAR(255)"`
	ExchangeRate         string    `json:"exchange_rate" xorm:"comment('兑换比例，固定为x:1') VARCHAR(255)"`
	UserLevelLimit       string    `json:"user_level_limit" xorm:"comment('用户等级限制组json') TEXT"`
	CreateAt             time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateAt             time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
	SettleCardinality    string    `json:"settle_cardinality" xorm:"comment('基数') VARCHAR(255)"`
	QuantityAllocation   int       `json:"quantity_allocation" xorm:"not null comment('数量分配 0按人数  1按份数') TINYINT(1)"`
}
