package model

import (
	"time"
)

type NewCapitalPoolBonus struct {
	Id                   int       `json:"id" xorm:"not null pk autoincr comment('主键id') INT(11)"`
	BonusPeriod          int       `json:"bonus_period" xorm:"not null comment('分红期数') INT(11)"`
	BonusValue           string    `json:"bonus_value" xorm:"not null default 0.000000 comment('分红资金') DECIMAL(12,6)"`
	RealBonusValue       string    `json:"real_bonus_value" xorm:"not null default 0.000000 comment('分红资金') DECIMAL(12,6)"`
	LossBonusValue       string    `json:"loss_bonus_value" xorm:"not null default 0.000000 comment('分红资金') DECIMAL(12,6)"`
	OutBonusValue        string    `json:"out_bonus_value" xorm:"not null default 0.000000 comment('分红资金') DECIMAL(12,6)"`
	BonusType            int       `json:"bonus_type" xorm:"not null default 1 comment('分红类型（1自动，2手动）') TINYINT(1)"`
	BonusCoinType        string    `json:"bonus_coin_type" xorm:"not null default '0' comment('佣金类型（CNY，虚拟币1Id，虚拟币2Id）多个以逗号隔开') VARCHAR(100)"`
	BonusUserLevelRecord string    `json:"bonus_user_level_record" xorm:"not null comment('分红时资金池设置用户等级分红的json') TEXT"`
	BonusUserRecord      string    `json:"bonus_user_record" xorm:"not null comment('分红时资金池设置用户分红的json') LONGTEXT"`
	BonusLevelType       int       `json:"bonus_level_type" xorm:"not null default 0 comment('用户等级分红类型（1，指定等级，2大于或等于指定等级）') TINYINT(1)"`
	BonusUserNum         string    `json:"bonus_user_num" xorm:"not null comment('分红时，用户分红用户等级，人数，分红类型，平均金额') TEXT"`
	Massage              string    `json:"massage" xorm:"not null comment('分红时错误日志信息') TEXT"`
	Comment              string    `json:"comment" xorm:"default '0' comment('备注') VARCHAR(255)"`
	CreateAt             time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`

	SecondBonusLevelType       int    `json:"second_bonus_level_type" xorm:"not null default 0 comment('用户等级分红类型（1，指定等级，2大于或等于指定等级）') TINYINT(1)"`
	SecondBonusUserLevelRecord string `json:"second_bonus_user_level_record" xorm:"not null comment('分红时资金池设置用户等级分红的json') TEXT"`
	SecondBonusUserRecord      string `json:"second_bonus_user_record" xorm:"not null comment('分红时资金池设置用户分红的json') LONGTEXT"`
	SecondBonusUserNum         string `json:"second_bonus_user_num" xorm:"not null comment('分红时，用户分红用户等级，人数，分红类型，平均金额') TEXT"`
	SecondMassage              string `json:"second_massage" xorm:"not null comment('分红时错误日志信息') TEXT"`
	FirstBili                  string `json:"first_bili" xorm:"not null comment('') DECIMAL(5,2)"`
	SecondBili                 string `json:"second_bili" xorm:"not null comment('') DECIMAL(5,2)"`
	QuantityAllocation         int    `json:"quantity_allocation" xorm:"not null comment('数量分配 0按人数  1按份数') TINYINT(1)"`
}
