package model

import (
	"time"
)

type NiuBeiCoinUserWithOrd struct {
	Id                    int       `json:"id" xorm:"not null pk autoincr comment('主键id') INT(11)"`
	Uid                   int       `json:"uid" xorm:"not null default 0 comment('uid') INT(11)"`
	OrdId                 string    `json:"ord_id" xorm:"not null default '0' comment('订单号') VARCHAR(100)"`
	Pvd                   int       `json:"pvd" xorm:"not null default 0 comment('平台') TINYINT(3)"`
	TotalConsumeCoinNum   string    `json:"total_consume_coin_num" xorm:"not null default 0.0000 comment('总消费积分数量') DECIMAL(10,4)"`
	ReleasedNiubeiCoinNum string    `json:"released_niubei_coin_num" xorm:"not null default 0.0000 comment('已释放牛贝积分数量') DECIMAL(10,4)"`
	ReleasedCouponCoinNum string    `json:"released_coupon_coin_num" xorm:"not null default 0.0000 comment('已释放抵扣劵数量') DECIMAL(10,4)"`
	ReleasedOptionCoinNum string    `json:"released_option_coin_num" xorm:"not null default 0.0000 comment('已释放期权积分数量') DECIMAL(10,4)"`
	ReleasedRatio         string    `json:"released_ratio" xorm:"not null default 0.0000 comment('已释放百分比') DECIMAL(10,4)"`
	IsReleasedFinish      int       `json:"is_released_finish" xorm:"not null default 0 comment('是否释放完毕(0:未释放完 1:释放完毕)') TINYINT(1)"`
	CreateAt              time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateAt              time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
}
