package model

type OneCirclesPublicPlatoonBasicSetting struct {
	Id                         int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	IsOpen                     int    `json:"is_open" xorm:"not null default 1 comment('是否开启(1:开启 0:关闭)') TINYINT(1)"`
	ExchangeRules              string `json:"exchange_rules" xorm:"not null comment('兑换规则') TEXT"`
	PersonActivePointsCoinId   int    `json:"person_active_points_coin_id" xorm:"not null default 0 comment('个人活跃积分对应虚拟币id') INT(11)"`
	TeamActivePointsCoinId     int    `json:"team_active_points_coin_id" xorm:"not null default 0 comment('团队活跃积分对应虚拟币id') INT(11)"`
	OriginatorUid              int    `json:"originator_uid" xorm:"not null default 0 comment('创始人uid') INT(11)"`
	SeveralTimes               int    `json:"several_times" xorm:"not null default 3 comment('几乘') TINYINT(3)"`
	SeveralRows                int    `json:"several_rows" xorm:"not null default 3 comment('几排') TINYINT(3)"`
	RevenueName                string `json:"revenue_name" xorm:"not null default '' comment('收益名称') VARCHAR(255)"`
	RewardSystem               string `json:"reward_system" xorm:"not null comment('奖励机制') TEXT"`
	VideoRewardIsOpen          int    `json:"video_reward_is_open" xorm:"not null default 1 comment('视屏奖励是否开启(1:开启 0:关闭)') TINYINT(1)"`
	VideoRewardSystem          string `json:"video_reward_system" xorm:"not null comment('视屏奖励机制') TEXT"`
	SystemPunishReplace        int    `json:"system_punish_replace" xorm:"not null default 1 comment('是否位置滑落 被新用户替换 0否 1是') TINYINT(1)"`
	SystemPunishReplaceValue   int    `json:"system_punish_replace_value" xorm:"not null default 0 comment('xx天未活跃，处罚滑落') INT(11)"`
	IsSelfActiveGetTeamRevenue int    `json:"is_self_active_get_team_revenue" xorm:"not null default 1 comment('会员本人没有日活，没有团队奖励(1:开启 0:关闭)') TINYINT(1)"`
	CreateAt                   string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt                   string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
