package model

import "time"

type PlanCommission struct {
	Id             int       `json:"id" xorm:"not null pk autoincr comment('分佣方案ID,现在只允许1,2') INT(10)"`
	PlanName       string    `json:"plan_name" xorm:"not null default '' comment('方案名称') VARCHAR(64)"`
	Memo           string    `json:"memo" xorm:"not null default '' comment('备注') VARCHAR(256)"`
	Mode           string    `json:"mode" xorm:"not null default '' comment('模式,lv_all级差按总佣金,lv_self级差按自购,lv_subsidy级差按补贴佣金') VARCHAR(16)"`
	Data           string    `json:"data" xorm:"comment('lv级别id,subsidy_mode:0按佣金计算,1按利润计算,self_rate自购比例,team_rate团队分成比例,peer_rate同级分成比例,subsidy_enable:0不开启，1：开启,subsidy_share_rate分享补贴比例,subsidy_self_reta自购补贴比例,payMode默认0（默认内部支出）') TEXT"`
	UpdateAt       time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' TIMESTAMP"`
	CommissionMode string    `json:"commission_mode" xorm:"default 'bili' comment('佣金返佣方式 比例 bili 固定金额 money') VARCHAR(16)"`
	IntegralMode   string    `json:"integral_mode" xorm:"default 'bili' comment('积分返佣方式 比例 bili 固定金额 money') VARCHAR(16)"`
	BlockIconsMode string    `json:"block_icons_mode" xorm:"default 'bili' comment('区块币返佣方式 比例 bili 固定金额 money') VARCHAR(16)"`
}
