package model

import (
	"time"
)

type RegionalAgentRegion struct {
	Id                    int64     `json:"id" xorm:"pk autoincr comment('表的主键id（亦可以代表省级id）') BIGINT(20)"`
	ProvinceId            int64     `json:"province_id" xorm:"comment('设置市级代理数据时，省级的id') BIGINT(20)"`
	CityId                int64     `json:"city_id" xorm:"comment('设置县区级代理数据时，市级的id') BIGINT(20)"`
	DistrictId            int64     `json:"district_id" xorm:"comment('设置网点代理数据时，县，区id') BIGINT(20)"`
	RegionName            string    `json:"region_name" xorm:"not null comment('地区名：（例如：广东省；广东省-珠海市；广东省-珠海市-香洲区；广东省-珠海市-香洲区-港湾一号）') VARCHAR(255)"`
	Name                  string    `json:"name" xorm:"not null comment('地区名）') VARCHAR(255)"`
	Longitude             string    `json:"longitude" xorm:"comment('经度（只有设置网点代理才会有数据）') DECIMAL(10,7)"`
	Latitude              string    `json:"latitude" xorm:"comment('纬度（只有设置网点代理才会有数据）') DECIMAL(10,7)"`
	AgPrice               string    `json:"ag_price" xorm:"not null comment('永久代理价格') DECIMAL(12,2)"`
	MonthAgPrice          string    `json:"month_ag_price" xorm:"not null comment('月代理价格') DECIMAL(12,2)"`
	QuarterAgPrice        string    `json:"quarter_ag_price" xorm:"not null comment('季度代理价格') DECIMAL(12,2)"`
	YearAgPrice           string    `json:"year_ag_price" xorm:"not null comment('年代理价格') DECIMAL(12,2)"`
	RenewalAgPrice        string    `json:"renewal_ag_price" xorm:"not null comment('续费永久代理价格') DECIMAL(12,2)"`
	RenewalMonthAgPrice   string    `json:"renewal_month_ag_price" xorm:"not null comment('续费月代理价格') DECIMAL(12,2)"`
	RenewalQuarterAgPrice string    `json:"renewal_quarter_ag_price" xorm:"not null comment('续费季度代理价格') DECIMAL(12,2)"`
	RenewalYearAgPrice    string    `json:"renewal_year_ag_price" xorm:"not null comment('续费年代理价格') DECIMAL(12,2)"`
	CommissionRate        string    `json:"commission_rate" xorm:"not null comment('分佣比例') DECIMAL(6,4)"`
	SubCommissionRate     string    `json:"sub_commission_rate" xorm:"not null comment('分佣比例') DECIMAL(6,4)"`
	ReturnedRate          string    `json:"returned_rate" xorm:"not null comment('返佣比例') DECIMAL(6,4)"`
	VirtualCurrencyRate   string    `json:"virtual_currency_rate" xorm:"not null comment('虚拟币比例') DECIMAL(6,4)"`
	LimitPerson           int       `json:"limit_person" xorm:"not null comment('限制人数（默认为0则不限制）') INT(11) "`
	Remark                string    `json:"remark" xorm:"comment('备注') VARCHAR(255)"`
	IsUse                 int       `json:"is_use" xorm:"not null default 1 comment('是否使用（否：0；是：1）') TINYINT(1)"`
	Level                 int       `json:"level" xorm:"not null default 0 comment('等级（1:省级；2:市级；3:区/县 级；4:网点）') TINYINT(1)"`
	CreateTime            time.Time `json:"create_time" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateTime            time.Time `json:"update_time" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
	WebsiteRegionId       string    `json:"website_region_id" xorm:"default '' comment('关联总后台地区的id') TIMESTAMP"`
	IsCustomer            int       `json:"is_customer" xorm:"not null default 1 comment('是否自定义新增的区域代理（否：0；是：1）') TINYINT(1)"`
}
