package model

import (
	"time"
)

type RegionalAgentSubUser struct {
	Id           int64     `json:"id" xorm:"pk autoincr BIGINT(20)"`
	SchemeId     int       `json:"scheme_id" xorm:"not null comment('方案id') INT(11)"`
	Uid          int       `json:"uid" xorm:"not null comment('参与区域代理的用户id') index(mgbgu_uid_ord_id_group_id_index) INT(11)"`
	RegionId     int       `json:"region_id" xorm:"not null comment('区域id') index(mgbgu_uid_ord_id_group_id_index) INT(11)"`
	IsFailure    int       `json:"is_failure" xorm:"not null default 0 comment('是否已失效：0否 1是') TINYINT(1)"`
	FailureTime  int       `json:"failure_time" xorm:"not null comment('剩下失效时间（单位：月）0代表永久') INT(11)"`
	ProvinceId   int64     `json:"province_id" xorm:"comment('省级区域id') BIGINT(20)"`
	CityId       int64     `json:"city_id" xorm:"comment('市级区域id') BIGINT(20)"`
	DistrictId   int64     `json:"district_id" xorm:"comment('区/县级id') BIGINT(20)"`
	SiteId       int64     `json:"site_id" xorm:"comment('网点id') BIGINT(20)"`
	RegionalName string    `json:"regional_name" xorm:"not null comment('地区名：（例如：广东省；广东省-珠海市；广东省-珠海市-香洲区；广东省-珠海市-香洲区-港湾一号）') VARCHAR(255)"`
	Level        int       `json:"level" xorm:"not null default 0 comment('等级（1:省级；2:市级；3:区/县 级；4:网点）') TINYINT(1)"`
	CreateTime   time.Time `json:"create_time" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') index(mgbgu_uid_ord_id_group_id_index) TIMESTAMP"`
	UpdateTime   time.Time `json:"update_time" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
	DeletedTime  time.Time `json:"deleted_time" xorm:"comment('删除时间') TIMESTAMP"`
	DateType     int       `json:"date_type" xorm:"not null comment('1:包月,2:包季,3:包年,4:永久') TINYINT(1)"`
	AutoRenewal  int       `json:"auto_renewal" xorm:"not null comment('是否自动续费0否 1是') TINYINT(1)"`
}
