package model

import (
	"time"
)

type RegionalSubAgentCalcSystemRelate struct {
	Id                    int64     `json:"id" xorm:"pk autoincr BIGINT(11)"`
	Uid                   int       `json:"uid" xorm:"not null comment('用户Id') INT(11)"`
	DivideAmount          float64   `json:"divide_amount" xorm:"not null comment('分佣所得金额') DOUBLE"`
	DivideVirtualCurrency string    `json:"divide_virtual_currency" xorm:"comment('分佣所得虚拟币详情') TEXT"`
	Ext                   string    `json:"ext" xorm:"comment('额外字段') TEXT"`
	Status                int       `json:"status" xorm:"not null default 1 comment('状态（1：未结算，2：已结算）') TINYINT(3)"`
	Type                  int       `json:"type" xorm:"not null default 1 comment('1:分佣记录 2:返佣记录') TINYINT(1)"`
	BelongOrdId           string    `json:"belong_ord_id" xorm:"not null comment('所属订单id') VARCHAR(255)"`
	Pvd                   string    `json:"pvd" xorm:"not null comment('渠道') VARCHAR(255)"`
	CreatedAt             time.Time `json:"created_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdatedAt             time.Time `json:"updated_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
}
