package model

import (
	"time"
)

type RegionalSubAgentOrdBelong struct {
	Id           int64     `json:"id" xorm:"pk autoincr BIGINT(20)"`
	Uid          int       `json:"uid" xorm:"not null comment('用户id') index(mgbgu_uid_ord_id_group_id_index) INT(11)"`
	Pvd          string    `json:"pvd" xorm:"not null comment('渠道：自营，导购，o2o。。。。') VARCHAR(255)"`
	OrderId      int64     `json:"order_id" xorm:"not null comment('订单id') BIGINT(20)"`
	CurrencyType int       `json:"currency_type" xorm:"not null default 1 comment('币种类型：（1:佣金，2:积分，3:区块币，4:...）') INT(3)"`
	Commission   string    `json:"commission" xorm:"not null comment('订单区域代理总佣金') DECIMAL(12,4)"`
	RegionId     int       `json:"region_id" xorm:"not null comment('区域id') INT(11)"`
	RegionalName string    `json:"regional_name" xorm:"not null comment('地区名：（例如：广东省；广东省-珠海市；广东省-珠海市-香洲区；广东省-珠海市-香洲区-港湾一号）') VARCHAR(255)"`
	ProvinceId   int64     `json:"province_id" xorm:"comment('省级区域id') BIGINT(20)"`
	CityId       int64     `json:"city_id" xorm:"comment('市级区域id') BIGINT(20)"`
	DistrictId   int64     `json:"district_id" xorm:"comment('区/县级id') BIGINT(20)"`
	SiteId       int64     `json:"site_id" xorm:"comment('网点id') BIGINT(20)"`
	CreateTime   time.Time `json:"create_time" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') index(mgbgu_uid_ord_id_group_id_index) TIMESTAMP"`
	UpdateTime   time.Time `json:"update_time" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
	Level        int       `json:"level" xorm:"not null default 0 comment('等级（1:省级；2:市级；3:区/县 级；4:网点）') TINYINT(1)"`
}
