package model

type SubsidyBase struct {
	Id                    int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	IsOpen                int    `json:"is_open" xorm:"default 0 comment('功能开关:') INT(1)"`
	LvId                  string `json:"lv_id" xorm:"comment('json [] 兑换等级:') VARCHAR(255)"`
	FloatSubsidyOpen      int    `json:"float_subsidy_open" xorm:"default 0 comment('浮动补贴比例:') INT(1)"`
	FloatSubsidyBili      int    `json:"float_subsidy_bili" xorm:"default 0 comment('浮动补贴比例:') INT(11)"`
	BaseSubsidyMoney      string `json:"base_subsidy_money" xorm:"default 0.00 comment('补贴基础金额设置:') DECIMAL(20,2)"`
	ConsumptionIntegral   string `json:"consumption_integral" xorm:"not null default 0.00 comment('消费积分数量') DECIMAL(20,2)"`
	ConsumptionMoney      string `json:"consumption_money" xorm:"default 0.00 comment('消费补贴') DECIMAL(20,2)"`
	ConsumptionTotalMoney string `json:"consumption_total_money" xorm:"default 0.00 comment('资金池 消费补贴(元)') DECIMAL(20,2)"`
	ExperienceIntegral    string `json:"experience_integral" xorm:"default 0.00 comment('体验积分数量') DECIMAL(20,2)"`
	ExperienceMoney       string `json:"experience_money" xorm:"default 0.00 comment('体验补贴') DECIMAL(20,2)"`
	ExperienceTotalMoney  string `json:"experience_total_money" xorm:"default 0.00 comment('资金池 体验补贴(元)') DECIMAL(20,2)"`
	ConsumptionDay        int    `json:"consumption_day" xorm:"default 0 comment('消费补贴兑换后第X天') INT(11)"`
	ExperienceDay         int    `json:"experience_day" xorm:"comment('体贴补贴兑换后第X天') VARCHAR(255)"`
	SettleTime            string `json:"settle_time" xorm:"comment('每天  XX:xx') VARCHAR(255)"`
	HolidaySettleOpen     int    `json:"holiday_settle_open" xorm:"default 0 comment('节假日是否结算') INT(1)"`
	SettlementDate        string `json:"settlement_date" xorm:"not null default '0000-00' comment('结算日期(0000-00)') CHAR(50)"`
}
