package model

import (
	"time"
)

type UserPublicPlatoonDoubleNetworkSetting struct {
	Id                 int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	IsOpen             int       `json:"is_open" xorm:"not null default 0 comment('是否开启(0:关闭 1:开启)') TINYINT(1)"`
	SeveralTimes       int       `json:"several_times" xorm:"not null default 0 comment('几乘') TINYINT(3)"`
	SeveralRows        int       `json:"several_rows" xorm:"not null default 0 comment('几排') TINYINT(3)"`
	OriginatorUid      int       `json:"originator_uid" xorm:"not null default -1 comment('创始人uid') INT(11)"`
	LastSettlementDate string    `json:"last_settlement_date" xorm:"not null default '0000-00-00' comment('上一次结算日期') CHAR(50)"`
	SettlementDate     string    `json:"settlement_date" xorm:"not null default '0000-00-00' comment('结算日期') CHAR(50)"`
	CoinId             int       `json:"coin_id" xorm:"not null default 0 comment('虚拟币id(作用于成长值)') INT(11)"`
	Ext                string    `json:"ext" xorm:"comment('拓展字段(json存储)') TEXT"`
	CreateAt           time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt           time.Time `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
