package model

import (
	"time"
)

type UserPublicPlatoonSetting struct {
	Id                                       int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	IsOpen                                   int       `json:"is_open" xorm:"not null default 0 comment('是否开启(0:关闭 1:开启)') TINYINT(1)"`
	SeveralTimes                             int       `json:"several_times" xorm:"not null default 0 comment('几乘') TINYINT(3)"`
	SeveralRows                              int       `json:"several_rows" xorm:"not null default 0 comment('几排') TINYINT(3)"`
	OriginatorUid                            int       `json:"originator_uid" xorm:"not null default -1 comment('创始人uid') INT(11)"`
	Ext                                      string    `json:"ext" xorm:"comment('拓展字段(json存储)') TEXT"`
	CreateAt                                 time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt                                 time.Time `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	SystemPunishTask                         string    `json:"system_punish_task" xorm:"comment('处罚任务条件') TEXT"`
	RewardTask                               string    `json:"reward_task" xorm:"comment('奖励任务条件') TEXT"`
	SystemPunishReplace                      int       `json:"system_punish_replace" xorm:"default 0 comment('是否位置滑落 被新用户替换 0否 1是') INT(1)"`
	SettleDay                                int       `json:"settle_day" xorm:"not null default 30 comment('结算天数') INT(11)"`
	IsUseSmallPublicPlatoon                  int       `json:"is_use_small_public_platoon" xorm:"not null default 0 comment('是否使用小公排(0:否 1:是)') INT(1)"`
	IsAllowNaturalUserJoinSmallPublicPlatoon int       `json:"is_allow_natural_user_join_small_public_platoon" xorm:"not null default 0 comment('是否允许自然用户加入小公排(0:否 1:是)') INT(1)"`
}
