package model

import (
	"time"
)

type UserPublicPlatoonSettlementRecords struct {
	Id       int64     `json:"id" xorm:"pk autoincr BIGINT(20)"`
	Uid      int       `json:"uid" xorm:"not null comment('用户id') index INT(11)"`
	CoinId   int       `json:"coin_id" xorm:"not null default 0 comment('虚拟币id(0为金额)') INT(11)"`
	Amount   string    `json:"amount" xorm:"not null default '' comment('结算金额') VARCHAR(50)"`
	Title    string    `json:"title" xorm:"comment('标题') VARCHAR(255)"`
	Date     string    `json:"date" xorm:"not null default '' comment('结算日期(0000-00)') VARCHAR(50)"`
	Kind     int       `json:"kind" xorm:"not null default 1 comment('结算种类(1:转入用户余额 2:清零)') TINYINT(1)"`
	Type     int       `json:"type" xorm:"not null default 1 comment('类型(1:大公排 2:小公排)') TINYINT(1)"`
	CreateAt time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt time.Time `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
