package enum

// 增值积分流水种类
type AppreciationFlowKind int

const (
	TransferIn AppreciationFlowKind = iota
	TransferOut
	WithdrawalAndDestroy
	WithdrawalAndReflux
)

func (kind AppreciationFlowKind) String() string {
	switch kind {
	case TransferIn:
		return "转入"
	case TransferOut:
		return "转出"
	case WithdrawalAndDestroy:
		return "提现销毁"
	case WithdrawalAndReflux:
		return "提现回流"
	default:
		return "未知状态"
	}
}
