package enum

// 退款状态
type BlockGreenChainFlowKind int

const (
	ConsumeIssue BlockGreenChainFlowKind = iota
	AirdropIssue
	ConsumeUnallocatedAndDestroy
	AirdropUnallocatedAndDestroy
	TransactionDestroy
	AdminDestroy
	SystemDestroyForGreen
)

func (kind BlockGreenChainFlowKind) String() string {
	switch kind {
	case ConsumeIssue:
		return "消费区发放"
	case AirdropIssue:
		return "空投区发放"
	case ConsumeUnallocatedAndDestroy:
		return "消费区未分配完销毁"
	case AirdropUnallocatedAndDestroy:
		return "空投区未分配完销毁"
	case TransactionDestroy:
		return "交易销毁"
	case AdminDestroy:
		return "管理员销毁"
	case SystemDestroyForGreen:
		return "系统销毁"
	default:
		return "未知状态"
	}
}
