package enum

// 退款状态
type BlockStarChainFlowKind int

const (
	SystemTimingIssue BlockStarChainFlowKind = iota
	SystemDestroy
	StaticUnallocatedAndDestroy
	DynamicallyUnallocatedAndDestroy
	OperationCenterUnallocatedAndDestroy
	OtherUnallocatedAndDestroy
	RewardDestroy
	RewardUnallocatedAndDestroy
	GroupLotteryAndDestroy
	RedEnvelopeTransferBalanceAndDestroy
	TransferFeeAndDestroy
)

func (kind BlockStarChainFlowKind) String() string {
	switch kind {
	case SystemTimingIssue:
		return "系统定时发放"
	case SystemDestroy:
		return "系统销毁"
	case StaticUnallocatedAndDestroy:
		return "静态未分配完销毁"
	case DynamicallyUnallocatedAndDestroy:
		return "动态未分配完销毁"
	case OperationCenterUnallocatedAndDestroy:
		return "运营中心未分配完销毁"
	case OtherUnallocatedAndDestroy:
		return "其他未分配完销毁"
	case RewardDestroy:
		return "打赏销毁"
	case RewardUnallocatedAndDestroy:
		return "打赏未分配完销毁"
	case GroupLotteryAndDestroy:
		return "自营拼团抽奖销毁"
	case RedEnvelopeTransferBalanceAndDestroy:
		return "红包转余额销毁"
	case TransferFeeAndDestroy:
		return "转增手续费销毁"
	default:
		return "未知状态"
	}
}
