package comm_plan

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"fmt"
	"xorm.io/xorm"
)

// 按总佣金的比例进行划分计算
func CalcWinery(opt *PlanOpt, totalAmt, integralTotalAmt float64, userList *LvUser, pvd string, sysFee float64, integralSysFee float64, level, levelWeight int, eg *xorm.Engine) error {
	grade := opt.UserRate
	if len(grade) == 0 {
		return zhios_order_relate_logx.Warn("level grade is not set")
	}

	//查出用户自购佣金
	commission, commissionRatio, amountList, ratioList := CalReturnAmountAndRatio(userList.Lv, userList.OwnbuyReturnType, 0, "own", totalAmt, integralTotalAmt, opt)
	userList.Profit = commission     // 另外出来的佣金 兼容旧的
	userList.ProfitList = amountList // 各币种分佣
	userList.SubsidyFee = 0
	ratioListMap := convertList2Map(ratioList)
	for k, v := range userList.ProfitList {
		userList.ProfitList[k].Val = ratioListMap[v.Cid] * v.Val
	}
	maxLvData, _ := db.UserLevelByID(eg, "2")
	// 各种币换算出总的额度
	totalAmtList := make([]*VirtualCoinCommission, 0)
	for coinId, rate := range opt.VirtualCoinMoneyRatioList {
		var amount float64
		if coinId == 0 {
			amount = totalAmt
		} else {
			amount = integralTotalAmt * zhios_order_relate_utils.AnyToFloat64(rate)
		}
		totalAmtList = append(totalAmtList, &VirtualCoinCommission{
			Cid: zhios_order_relate_utils.AnyToString(coinId),
			Val: amount,
		})
	}

	var (
		node                            = userList
		maxLv                           = node.Lv                           // 当前等级
		maxLevelWeight                  = node.LevelWeight                  // 当前权重
		peerNum                         = 0                                 // 存在同级数
		peerRate                float64 = 0                                 // 同级累计比例
		peerRateList                    = make([]*VirtualCoinCommission, 0) // 各虚拟币同级累计
		restAmtList                     = make([]*VirtualCoinCommission, 0) // 各虚拟币剩余额度
		accumulateRatioList             = make([]*VirtualCoinCommission, 0) // 各虚拟币累计比例
		newAccumulateRatioList          = make([]*VirtualCoinCommission, 0) // 各虚拟币累计比例
		restAmt                         = totalAmt - userList.Profit        // 剩余比例
		totalCommissionRatio            = commissionRatio                   // 累计佣金比例
		newTotalCommissionRatio float64 = 0                                 // 累计佣金比例
		sameProfit              float64 = 0
		sameProfitList                  = make([]*VirtualCoinCommission, 0)
		isCus                           = 0
		extendUid                       = 0
		isEnd                           = 0
	)
	// 计算剩余额度
	restAmtList, _ = CalVirtualCommissionMinus(totalAmtList, amountList)
	// 累计比例
	accumulateRatioList = ratioList
	restAmt = zhios_order_relate_utils.FloatFormat(restAmt, 2)
	teamCountMinData, _ := db.SysCfgGetOne(eg, "team_count_min")
	teamCountMin := 15
	if teamCountMinData != nil {
		teamCountMin = zhios_order_relate_utils.StrToInt(teamCountMinData.Val)
	}
Loop:
	for node.ParentUser != nil { //查找上级用户
		node.ParentUser.Profit = 0

		//佣金补贴奖励
		subsidyFee, subsidyRatio, isOnlySubsidyFee, subsidyFeeList, subsidyRatioList := subsidyFeeDo(opt, totalAmt, integralTotalAmt, node.ParentUser, userList.NewLv, pvd, sysFee, integralSysFee)
		node.ParentUser.SubsidyFee = subsidyFee
		node.ParentUser.SubsidyFeeList = subsidyFeeList // 各币种补贴

		// 如果父级比当前级别低, 跳过
		// 同级奖, 如果父级别与当前级别一致,并且设置了对应比例
		count := len(grade[maxLv].PeerRate)
		if grade[maxLv].PeerRateList != nil {
			count = len(grade[maxLv].PeerRateList)
		}
		var isBreak bool
		zeroList := make(map[string]struct{})
		if isEnd != 1 {
			if node.ParentUser.Lv > 0 { //不是粉丝
				//定位
				isPostion := 0
				if node.ParentUser.ParentUser != nil && node.ParentUser.Lv > 0 {
					//找出前两个人 如果不是就分团队奖 如果是就再找
					sql := `SELECT u.uid,u.first_arrive_at FROM user_profile up
						LEFT JOIN user u on u.uid=up.uid
						WHERE up.parent_uid=? and u.level>0 ORDER BY u.first_arrive_at asc,u.uid asc LIMIT 2`
					nativeString, err := db.QueryNativeString(eg, sql, node.ParentUser.ParentUser.Uid)
					if err != nil {
						return zhios_order_relate_logx.Warn("sql error")
					}
					if len(nativeString) > 0 {
						for _, v := range nativeString {
							if zhios_order_relate_utils.StrToInt(v["uid"]) == node.ParentUser.Uid {
								isPostion = 1
							}
						}
					}
				}

				commission, _, amountList, teamRatioList := CalReturnAmountAndRatioExtendWinery(node.ParentUser.Lv, userList.OwnbuyReturnType, peerNum, "extend_lv", totalAmt, integralTotalAmt, opt, isPostion)
				//佣金
				node.ParentUser.Profit = commission
				node.ParentUser.Profit, restAmt, totalCommissionRatio, node.ParentUser.SubsidyFee, isBreak = extendDiffMoney(node.ParentUser.Profit, grade[node.Lv].PayMode, isOnlySubsidyFee, totalAmt, restAmt, grade[node.ParentUser.Lv].TeamRate, totalCommissionRatio, peerRate, node.ParentUser.SubsidyFee, subsidyRatio)
				//积分
				node.ParentUser.ProfitList = amountList
				node.ParentUser.ProfitList, restAmtList, accumulateRatioList, node.ParentUser.SubsidyFeeList, zeroList = extendDiffMoneyV2(node.ParentUser.ProfitList, grade[node.Lv].PayMode, isOnlySubsidyFee, totalAmtList, restAmtList, teamRatioList, accumulateRatioList, peerRateList, subsidyFeeList, subsidyRatioList)
				isEnd = 1
				// 没得分了 就结束
				if isBreak && len(zeroList) == len(opt.UserRate[maxLv].ReturnType) {
					break Loop
				}
				if node.ParentUser.Lv > 2 && maxLvData != nil {
					node.ParentUser.LevelWeight = maxLvData.LevelWeight
				}
				if isPostion == 1 { //只要是前2个会员 都走店员----店员逻辑
					isCus = 1
					extendUid = node.ParentUser.Uid
				} else {
					maxLevelWeight, maxLv, peerRate, peerRateList, peerNum, sameProfit, sameProfitList, isCus, extendUid = node.ParentUser.LevelWeight, node.ParentUser.Lv, 0, nil, 0, node.ParentUser.Profit, node.ParentUser.ProfitList, isCus, extendUid
				}
			}
		} else {
			isNext := 0
			//如果前一等级是团长 就不用判断这个了
			if isCus == 1 && extendUid > 0 { //店员才有值
				//找出前两个人 如果不是就分团队奖 如果是就再找
				sql := `SELECT u.uid,u.first_arrive_at FROM user_profile up
						LEFT JOIN user u on u.uid=up.uid
						WHERE up.parent_uid=? and u.level>0  ORDER BY u.first_arrive_at asc,u.uid asc LIMIT 2`
				nativeString, err := db.QueryNativeString(eg, sql, node.ParentUser.Uid)
				if err != nil {
					return zhios_order_relate_logx.Warn("sql error")
				}
				if len(nativeString) > 0 {
					for _, v := range nativeString {
						if zhios_order_relate_utils.StrToInt(v["uid"]) == extendUid {
							isNext = 1
							extendUid = node.ParentUser.Uid
						}
					}
				}
			}
			if node.ParentUser.Lv > 2 && maxLvData != nil {
				node.ParentUser.LevelWeight = maxLvData.LevelWeight
			}
			if isNext == 0 {
				// 同级奖
				if node.ParentUser.LevelWeight == maxLevelWeight && count > peerNum {
					if peerNum >= 1 && node.ParentUser.Lv >= 2 {
						teamtotal := db.GetUserTeamTotal(eg, zhios_order_relate_utils.IntToStr(node.ParentUser.Uid))
						if teamtotal != nil && teamtotal.IsSet == 1 {
							node.ParentUser.IsFreeze = 0
						} else {
							checkCond(eg, node.ParentUser.Uid, teamCountMin)
							node.ParentUser.IsFreeze = Check(eg, node.ParentUser.Uid, teamCountMin)
						}
					}
					peerRate = 0
					//同级奖励比例
					commission, commissionRatio, amountList, ratioList := CalReturnAmountAndRatioWinery(maxLv, userList.OwnbuyReturnType, peerNum, "same_lv", sameProfit, sameProfitList, opt)
					//佣金                                                                                                           (lv,     isOnlySubsidy int, restAmt, profit, peerRate,      totalRatio,          restRatio,            subsidyFee, subsidyBili float64, opt *PlanOpt)
					node.ParentUser.Profit, restAmt, totalCommissionRatio, peerRate, node.ParentUser.SubsidyFee, isBreak = sameMoneyWinery(node.Lv, isOnlySubsidyFee, restAmt, commission, peerRate, totalCommissionRatio, commissionRatio, node.ParentUser.SubsidyFee, subsidyRatio, opt)
					node.ParentUser.ProfitList, restAmtList, accumulateRatioList, peerRateList, node.ParentUser.SubsidyFeeList, zeroList = sameMoneyV2Winery(node.Lv, isOnlySubsidyFee, totalAmtList, restAmtList, amountList, peerRateList, accumulateRatioList, ratioList, node.ParentUser.SubsidyFeeList, subsidyRatioList, opt)

					// 全部都没得分了
					if isBreak && len(zeroList) == len(opt.UserRate[maxLv].ReturnType) {
						break Loop
					}
					isCus = 0
					extendUid = 0
					peerNum++
				} else if node.ParentUser.LevelWeight > maxLevelWeight {
					if _, ok := grade[node.Lv]; !ok {
						return zhios_order_relate_logx.Warn("level grade node.Lv is not set")
					}
					if _, ok := grade[node.ParentUser.Lv]; !ok {
						return zhios_order_relate_logx.Warn("level grade node.ParentUser.Lv is not set")
					}

					//原来的团队奖
					commission1, _, amountList1, teamRatioList1 := CalReturnAmountAndRatioWineryTeam(node.ParentUser.Lv, userList.OwnbuyReturnType, peerNum, "team", totalAmt, integralTotalAmt, opt)
					//佣金
					node.ParentUser.Profit = commission1
					node.ParentUser.Profit, restAmt, totalCommissionRatio, node.ParentUser.SubsidyFee, isBreak = teamDiffMoneyWinery(node.ParentUser.Profit, grade[node.Lv].PayMode, isOnlySubsidyFee, totalAmt, restAmt, grade[node.ParentUser.Lv].TeamRate, totalCommissionRatio, peerRate, node.ParentUser.SubsidyFee, subsidyRatio)
					//积分
					node.ParentUser.ProfitList = amountList1
					node.ParentUser.ProfitList, restAmtList, accumulateRatioList, node.ParentUser.SubsidyFeeList, zeroList = teamDiffMoneyV2Winery(node.ParentUser.ProfitList, grade[node.Lv].PayMode, isOnlySubsidyFee, totalAmtList, restAmtList, teamRatioList1, accumulateRatioList, peerRateList, subsidyFeeList, subsidyRatioList)

					// 没得分了 就结束
					if isBreak && len(zeroList) == len(opt.UserRate[maxLv].ReturnType) {
						break Loop
					}
					if node.ParentUser.Lv > 2 && maxLvData != nil {
						node.ParentUser.LevelWeight = maxLvData.LevelWeight
					}
					// 等级往上升则置0
					maxLevelWeight, maxLv, peerRate, peerRateList, peerNum, sameProfit, sameProfitList, isCus, extendUid = node.ParentUser.LevelWeight, node.ParentUser.Lv, 0, nil, 0, node.ParentUser.Profit, node.ParentUser.ProfitList, 0, 0
				}
			}
		}
		//新的团队奖
		commission, _, amountList, teamRatioList := CalReturnAmountAndRatioWineryTeamNew(node.ParentUser.Lv, userList.OwnbuyReturnType, peerNum, "new_team", totalAmt, integralTotalAmt, opt)
		commission, restAmt, newTotalCommissionRatio, node.ParentUser.SubsidyFee, isBreak = teamDiffMoneyWineryNew(node.ParentUser.Profit, grade[node.Lv].PayMode, isOnlySubsidyFee, totalAmt, restAmt, grade[node.ParentUser.Lv].TeamRate, newTotalCommissionRatio, peerRate, node.ParentUser.SubsidyFee, subsidyRatio)
		amountList, restAmtList, newAccumulateRatioList, node.ParentUser.SubsidyFeeList, zeroList = teamDiffMoneyV2WineryNew(opt, node.ParentUser.ProfitList, grade[node.Lv].PayMode, isOnlySubsidyFee, totalAmtList, restAmtList, teamRatioList, newAccumulateRatioList, peerRateList, subsidyFeeList, subsidyRatioList)
		amountMap := make(map[string]float64)
		for _, v := range amountList {
			amountMap[v.Cid] = v.Val
		}
		for _, v := range node.ParentUser.ProfitList {
			amountMap[v.Cid] += v.Val
		}
		var tmp = make([]*VirtualCoinCommission, 0)
		for k, v := range amountMap {
			var tmp1 = &VirtualCoinCommission{Cid: k, Val: v}
			tmp = append(tmp, tmp1)
		}
		node.ParentUser.Profit += commission
		node.ParentUser.ProfitList = tmp

		//如果是酒庄制度，要看这里处理 额外的补贴
		subsidyFee, subsidyRatio, isOnlySubsidyFee, subsidyFeeList, subsidyRatioList = subsidyFeeDo(opt, totalAmt, integralTotalAmt, node.ParentUser, userList.NewLv, pvd, sysFee, integralSysFee)
		node.ParentUser.SubsidyFee = subsidyFee
		node.ParentUser.SubsidyFeeList = subsidyFeeList // 各币种补贴
		node.Profit = zhios_order_relate_utils.StrToFloat64(fmt.Sprintf("%.4f", node.Profit))
		node = node.ParentUser
	}

	return nil
}
func Check(eg *xorm.Engine, uid, teamCountMin int) int {
	//找出前两个人 如果不是就分团队奖 如果是就再找
	sql := `SELECT u.uid,u.first_arrive_at FROM user_profile up
						LEFT JOIN user u on u.uid=up.uid
						WHERE up.parent_uid=? and u.level>0  ORDER BY u.first_arrive_at asc,u.uid asc LIMIT 2`
	nativeString, err := db.QueryNativeString(eg, sql, uid)
	if err != nil {
		return 1
	}
	isAllFreeze := 1
	firstCount := 0
	secondCount := 0
	for k, v := range nativeString {
		isfreeze, count := checkCond(eg, zhios_order_relate_utils.StrToInt(v["uid"]), teamCountMin)
		if isfreeze == 0 {
			isAllFreeze = 0
		} else {
			isAllFreeze = 1
		}
		if k == 0 {
			firstCount = count
		}
		if k == 1 {
			secondCount = count
		}
	}
	eg.Where("uid=?", uid).Cols("first_count,second_count").Update(&model.UserTeamTotal{FirstCount: firstCount, SecondCount: secondCount})
	if len(nativeString) < 2 {
		return 1
	}
	return isAllFreeze
}
func checkCond(eg *xorm.Engine, uid, teamCountMin int) (int, int) {
	isfreeze := 1
	teamtotal := db.GetUserTeamTotal(eg, zhios_order_relate_utils.IntToStr(uid))
	total := 0
	if teamtotal == nil || teamtotal != nil && teamtotal.TeamCount < teamCountMin {
		sql1 := `SELECT ur.uid,up.parent_uid,ur.level FROM user_relate ur
				LEFT JOIN user_profile up on ur.uid=up.uid
				LEFT JOIN user u on u.uid=ur.uid
				WHERE ur.parent_uid=? and u.level>0 and ur.level<20 ORDER BY ur.level asc,u.first_arrive_at asc,u.uid asc 
				`
		nativeString1, _ := db.QueryNativeString(eg, sql1, uid)
		if len(nativeString1) > 0 {
			var nMap = make(map[string][]string)
			nCount := 0
			for _, v := range nativeString1 {
				if zhios_order_relate_utils.StrToInt(v["uid"]) == 0 || nCount >= teamCountMin {
					continue
				}
				if v["level"] == "1" && len(nMap[v["level"]]) < 2 {
					nMap[v["level"]] = append(nMap[v["level"]], v["uid"])
					nCount++
				} else if len(nMap[v["level"]]) < 2 {
					lastLevel := zhios_order_relate_utils.IntToStr(zhios_order_relate_utils.StrToInt(v["level"]) - 1)
					for _, v1 := range nMap[lastLevel] {
						if v["parent_uid"] == v1 {
							nMap[v["level"]] = append(nMap[v["level"]], v["uid"])
							nCount++
						}
					}
				}
			}
			if teamtotal != nil {
				teamtotal.TeamCount = nCount
				eg.Where("uid=?", uid).Update(teamtotal)
			}

			total = nCount
		}
	} else {
		total = teamtotal.TeamCount
	}
	if total >= teamCountMin {
		isfreeze = 0
	}
	return isfreeze, total
}

func teamDiffMoneyWinery(profit float64, payMode, isOnlySubsidy int, totalAmt, restAmt, teamRatio, totalRatio, peerRate, subsidyFee, subsidyRatio float64) (float64, float64, float64, float64, bool) {
	// 如果是团队内部支出团队比例大于同级累计比例 或站长支出
	if payMode == 1 || teamRatio > peerRate {
		teamRatio = zhios_order_relate_utils.FloatFormat(teamRatio-totalRatio, 6)
	}
	//极差返利
	if isOnlySubsidy == 0 {
		totalRatio += teamRatio
		//出现负数跳过
		if teamRatio <= 0 {
			profit = 0
			return profit, restAmt, totalRatio, subsidyFee, true
		}
		profit = zhios_order_relate_utils.FloatFormat(teamRatio*totalAmt, 2)
		if restAmt < profit {
			profit = 0
			return profit, restAmt, totalRatio, subsidyFee, true
		}
		restAmt -= profit // 剩余可分

	} else if isOnlySubsidy == 1 { //如果只返补贴  当成是极差的一部分 所以要扣 不是额外的
		totalRatio += zhios_order_relate_utils.FloatFormat(subsidyRatio, 6)
		profit = 0
		if restAmt < subsidyFee {
			profit = 0
			subsidyFee = 0
			return profit, restAmt, totalRatio, subsidyFee, true
		}
		restAmt -= subsidyFee // 剩余可分
	}
	restAmt = zhios_order_relate_utils.FloatFormat(restAmt, 2)
	return profit, restAmt, totalRatio, subsidyFee, false
}

// 处理多虚拟币团队的
func teamDiffMoneyV2Winery(profitList []*VirtualCoinCommission, payMode, isOnlySubsidy int, totalAmtList, restAmtList, teamRatioList, totalRatioList, peerRateList, subsidyFeeList, subsidyRatioList []*VirtualCoinCommission) (newProfitList, newRestAmtList, newTotalRatioList, newSubsidyFeeList []*VirtualCoinCommission, zeroList map[string]struct{}) {
	restAmtMap := convertList2Map(restAmtList)
	totalAmtMap := convertList2Map(totalAmtList)
	profitMap := convertList2Map(profitList)
	totalRatioMap := convertList2Map(totalRatioList)
	peerRateMap := convertList2Map(peerRateList)
	subsidyFeeMap := convertList2Map(subsidyFeeList)
	subsidyRatioMap := convertList2Map(subsidyRatioList)
	teamRatioMap := convertList2Map(teamRatioList)

	zeroList = make(map[string]struct{})
	newProfitList = make([]*VirtualCoinCommission, 0)

	for _, coin := range profitList {
		// 如果是团队内部支出团队比例大于同级累计比例 或站长支出
		if payMode == 1 || teamRatioMap[coin.Cid] > peerRateMap[coin.Cid] {
			teamRatioMap[coin.Cid] = zhios_order_relate_utils.FloatFormat(teamRatioMap[coin.Cid]-totalRatioMap[coin.Cid], 6)
		}

		if isOnlySubsidy == 0 {
			totalRatioMap[coin.Cid] += teamRatioMap[coin.Cid]

			profitOne := &VirtualCoinCommission{}
			profitOne.Cid = coin.Cid
			profitOne.Val = zhios_order_relate_utils.FloatFormat(totalAmtMap[coin.Cid]*teamRatioMap[coin.Cid], 6)
			// 剩余不足或比例小于0
			if teamRatioMap[coin.Cid] < 0 || restAmtMap[coin.Cid] < profitOne.Val {
				zeroList[coin.Cid] = struct{}{}
				profitOne.Val = 0
			}
			newProfitList = append(newProfitList, profitOne)

			restAmtMap[coin.Cid] -= profitOne.Val
		} else if isOnlySubsidy == 1 { //如果只返补贴  当成是极差的一部分 所以要扣 不是额外的
			totalRatioMap[coin.Cid] += zhios_order_relate_utils.FloatFormat(subsidyRatioMap[coin.Cid], 6)
			profitMap[coin.Cid] = 0
			if restAmtMap[coin.Cid] < subsidyFeeMap[coin.Cid] {
				subsidyFeeMap[coin.Cid] = 0
			}
			restAmtMap[coin.Cid] -= subsidyFeeMap[coin.Cid]
		}
	}
	newTotalRatioList = convertMap2List(totalRatioMap)
	newRestAmtList = convertMap2List(restAmtMap)
	newSubsidyFeeList = convertMap2List(subsidyFeeMap)

	return newProfitList, newRestAmtList, newTotalRatioList, newSubsidyFeeList, zeroList
}
func teamDiffMoneyWineryNew(profit float64, payMode, isOnlySubsidy int, totalAmt, restAmt, teamRatio, totalRatio, peerRate, subsidyFee, subsidyRatio float64) (float64, float64, float64, float64, bool) {
	// 如果是团队内部支出团队比例大于同级累计比例 或站长支出
	teamRatio = zhios_order_relate_utils.FloatFormat(teamRatio-totalRatio, 6)
	//极差返利
	if isOnlySubsidy == 0 {
		totalRatio += teamRatio
		//出现负数跳过
		if teamRatio <= 0 {
			profit = 0
			return profit, restAmt, totalRatio, subsidyFee, true
		}
		profit = zhios_order_relate_utils.FloatFormat(teamRatio*totalAmt, 2)
		if restAmt < profit {
			profit = 0
			return profit, restAmt, totalRatio, subsidyFee, true
		}
		restAmt -= profit // 剩余可分

	} else if isOnlySubsidy == 1 { //如果只返补贴  当成是极差的一部分 所以要扣 不是额外的
		totalRatio += zhios_order_relate_utils.FloatFormat(subsidyRatio, 6)
		profit = 0
		if restAmt < subsidyFee {
			profit = 0
			subsidyFee = 0
			return profit, restAmt, totalRatio, subsidyFee, true
		}
		restAmt -= subsidyFee // 剩余可分
	}
	restAmt = zhios_order_relate_utils.FloatFormat(restAmt, 2)
	return profit, restAmt, totalRatio, subsidyFee, false
}

// 处理多虚拟币团队的
func teamDiffMoneyV2WineryNew(opt *PlanOpt, profitList []*VirtualCoinCommission, payMode, isOnlySubsidy int, totalAmtList, restAmtList, teamRatioList, totalRatioList, peerRateList, subsidyFeeList, subsidyRatioList []*VirtualCoinCommission) (newProfitList, newRestAmtList, newTotalRatioList, newSubsidyFeeList []*VirtualCoinCommission, zeroList map[string]struct{}) {
	if len(profitList) == 0 {
		var returnType = make([]string, 0)
		var maxReturnTypeCount = 0
		for _, v := range opt.UserRate {
			if v.ReturnType != nil {
				if len(v.ReturnType) > maxReturnTypeCount {
					maxReturnTypeCount = len(v.ReturnType)
					returnType = v.ReturnType
				}
			}
		}
		// 新版支持多种虚拟币 支持的种类id保存在ReturnType  id=0代表现金佣金 其他为虚拟币
		if returnType != nil { //返佣类型
			for _, coinId := range returnType {
				profitList = append(profitList, &VirtualCoinCommission{
					Cid: coinId,
					Val: 0,
				})

			}
		}
	}

	restAmtMap := convertList2Map(restAmtList)
	totalAmtMap := convertList2Map(totalAmtList)
	profitMap := convertList2Map(profitList)
	totalRatioMap := convertList2Map(totalRatioList)
	subsidyFeeMap := convertList2Map(subsidyFeeList)
	subsidyRatioMap := convertList2Map(subsidyRatioList)
	teamRatioMap := convertList2Map(teamRatioList)

	zeroList = make(map[string]struct{})
	newProfitList = make([]*VirtualCoinCommission, 0)

	for _, coin := range profitList {
		if teamRatioMap[coin.Cid] == 0 {
			continue
		}
		// 如果是团队内部支出团队比例大于同级累计比例 或站长支出
		teamRatioMap[coin.Cid] = zhios_order_relate_utils.FloatFormat(teamRatioMap[coin.Cid]-totalRatioMap[coin.Cid], 6)

		if isOnlySubsidy == 0 {
			totalRatioMap[coin.Cid] += teamRatioMap[coin.Cid]

			profitOne := &VirtualCoinCommission{}
			profitOne.Cid = coin.Cid
			profitOne.Val = zhios_order_relate_utils.FloatFormat(totalAmtMap[coin.Cid]*teamRatioMap[coin.Cid], 6)
			// 剩余不足或比例小于0
			if teamRatioMap[coin.Cid] < 0 || restAmtMap[coin.Cid] < profitOne.Val {
				zeroList[coin.Cid] = struct{}{}
				profitOne.Val = 0
			}
			newProfitList = append(newProfitList, profitOne)

			restAmtMap[coin.Cid] -= profitOne.Val
		} else if isOnlySubsidy == 1 { //如果只返补贴  当成是极差的一部分 所以要扣 不是额外的
			totalRatioMap[coin.Cid] += zhios_order_relate_utils.FloatFormat(subsidyRatioMap[coin.Cid], 6)
			profitMap[coin.Cid] = 0
			if restAmtMap[coin.Cid] < subsidyFeeMap[coin.Cid] {
				subsidyFeeMap[coin.Cid] = 0
			}
			restAmtMap[coin.Cid] -= subsidyFeeMap[coin.Cid]
		}
	}
	newTotalRatioList = convertMap2List(totalRatioMap)
	newRestAmtList = convertMap2List(restAmtMap)
	newSubsidyFeeList = convertMap2List(subsidyFeeMap)

	return newProfitList, newRestAmtList, newTotalRatioList, newSubsidyFeeList, zeroList
}

func CalReturnAmountAndRatioWineryTeam(level, ownbuyReturnType, peerNum int, userType string, fee, integralFee float64, opt *PlanOpt) (commission, commissionRatio float64, amountList, ratioList []*VirtualCoinCommission) {
	// 佣金的比例兼容旧系统 比例独立出来的 所以这样算
	commissionRatio = getCommissionRatio(userType, level, peerNum, opt.UserRate)
	commission = fee * commissionRatio
	var maxReturnTypeCount = 0
	var returnType = make([]string, 0)
	for _, v := range opt.UserRate {
		if v.ReturnType != nil {
			if len(v.ReturnType) > maxReturnTypeCount {
				maxReturnTypeCount = len(v.ReturnType)
				returnType = v.ReturnType
			}
		}
	}
	// 新版支持多种虚拟币 支持的种类id保存在ReturnType  id=0代表现金佣金 其他为虚拟币
	if returnType != nil { //返佣类型
		for _, coinId := range returnType {
			newFee := integralFee
			if coinId == "0" {
				newFee = fee
			}
			ratio := getVirtualCoinRatio(userType, level, peerNum, opt.UserRate, coinId, 0)
			amount := getCoinAmount(ratio, zhios_order_relate_utils.StrToInt(coinId), newFee, opt.VirtualCoinMoneyRatioList)
			if coinId != "0" && opt.Mode == "lv_winery" && userType == "own" { //酒庄模式不在这里计算
				amount = 0
			}
			amountList = append(amountList, &VirtualCoinCommission{
				Cid: coinId,
				Val: amount,
			})
			ratioList = append(ratioList, &VirtualCoinCommission{
				Cid: coinId,
				Val: zhios_order_relate_utils.AnyToFloat64(ratio),
			})
		}
	}

	if ownbuyReturnType == 1 { //自购不返利
		commission = 0
		for i := range amountList {
			amountList[i].Val = 0
		}
	}
	commission = zhios_order_relate_utils.FloatFormat(commission, 2)

	for i, coin := range amountList {
		amountList[i].Val = zhios_order_relate_utils.FloatFormat(coin.Val, 6)
	}

	return commission, commissionRatio, amountList, ratioList
}

func CalReturnAmountAndRatioWineryTeamNew(level, ownbuyReturnType, peerNum int, userType string, fee, integralFee float64, opt *PlanOpt) (commission, commissionRatio float64, amountList, ratioList []*VirtualCoinCommission) {
	var maxReturnTypeCount = 0
	var returnType = make([]string, 0)
	for _, v := range opt.UserRate {
		if v.ReturnType != nil {
			if len(v.ReturnType) > maxReturnTypeCount {
				maxReturnTypeCount = len(v.ReturnType)
				returnType = v.ReturnType
			}
		}
	}
	// 新版支持多种虚拟币 支持的种类id保存在ReturnType  id=0代表现金佣金 其他为虚拟币
	if returnType != nil { //返佣类型
		for _, coinId := range returnType {
			newFee := integralFee
			if coinId == "0" {
				newFee = fee
			}
			ratio := getVirtualCoinRatio(userType, level, peerNum, opt.UserRate, coinId, 0)
			amount := getCoinAmount(ratio, zhios_order_relate_utils.StrToInt(coinId), newFee, opt.VirtualCoinMoneyRatioList)
			if coinId != "0" && opt.Mode == "lv_winery" && userType == "own" { //酒庄模式不在这里计算
				amount = 0
			}
			if coinId == "0" {
				commission = amount
			}
			amountList = append(amountList, &VirtualCoinCommission{
				Cid: coinId,
				Val: amount,
			})
			ratioList = append(ratioList, &VirtualCoinCommission{
				Cid: coinId,
				Val: zhios_order_relate_utils.AnyToFloat64(ratio),
			})
		}
	}

	if ownbuyReturnType == 1 { //自购不返利
		commission = 0
		for i := range amountList {
			amountList[i].Val = 0
		}
	}
	commission = zhios_order_relate_utils.FloatFormat(commission, 2)

	for i, coin := range amountList {
		amountList[i].Val = zhios_order_relate_utils.FloatFormat(coin.Val, 6)
	}

	return commission, commissionRatio, amountList, ratioList
}

func CalReturnAmountAndRatioWinery(level, ownbuyReturnType, peerNum int, userType string, profit float64, profitList []*VirtualCoinCommission, opt *PlanOpt) (commission, commissionRatio float64, amountList, ratioList []*VirtualCoinCommission) {
	// 佣金的比例兼容旧系统 比例独立出来的 所以这样算
	commissionRatio = getCommissionRatio(userType, level, peerNum, opt.UserRate)
	commission = profit * commissionRatio
	var maxReturnTypeCount = 0
	var returnType = make([]string, 0)
	for _, v := range opt.UserRate {
		if v.ReturnType != nil {
			if len(v.ReturnType) > maxReturnTypeCount {
				maxReturnTypeCount = len(v.ReturnType)
				returnType = v.ReturnType
			}
		}
	}
	profitListMap := make(map[string]float64)
	for _, v := range profitList {
		profitListMap[v.Cid] = v.Val
	}
	// 新版支持多种虚拟币 支持的种类id保存在ReturnType  id=0代表现金佣金 其他为虚拟币
	if returnType != nil { //返佣类型

		for _, coinId := range returnType {
			newFee := profitListMap[coinId]
			if coinId == "0" {
				newFee = profit
			}
			ratio := getVirtualCoinRatio(userType, level, peerNum, opt.UserRate, coinId, 0)
			amount := getCoinAmount(ratio, zhios_order_relate_utils.StrToInt(coinId), newFee, opt.VirtualCoinMoneyRatioList)
			if coinId != "0" && opt.Mode == "lv_winery" && userType == "own" { //酒庄模式不在这里计算
				amount = 0
			}
			amountList = append(amountList, &VirtualCoinCommission{
				Cid: coinId,
				Val: amount,
			})
			ratioList = append(ratioList, &VirtualCoinCommission{
				Cid: coinId,
				Val: zhios_order_relate_utils.AnyToFloat64(ratio),
			})
		}
	}

	if ownbuyReturnType == 1 { //自购不返利
		commission = 0
		for i := range amountList {
			amountList[i].Val = 0
		}
	}
	commission = zhios_order_relate_utils.FloatFormat(commission, 2)

	for i, coin := range amountList {
		amountList[i].Val = zhios_order_relate_utils.FloatFormat(coin.Val, 6)
	}

	return commission, commissionRatio, amountList, ratioList
}
func CalReturnAmountAndRatioExtendWinery(level, ownbuyReturnType, peerNum int, userType string, fee, integralFee float64, opt *PlanOpt, isPostion int) (commission, commissionRatio float64, amountList, ratioList []*VirtualCoinCommission) {
	var maxReturnTypeCount = 0
	var returnType = make([]string, 0)
	for _, v := range opt.UserRate {
		if v.ReturnType != nil {
			if len(v.ReturnType) > maxReturnTypeCount {
				maxReturnTypeCount = len(v.ReturnType)
				returnType = v.ReturnType
			}
		}
	}
	// 新版支持多种虚拟币 支持的种类id保存在ReturnType  id=0代表现金佣金 其他为虚拟币
	if returnType != nil { //返佣类型
		for _, coinId := range returnType {
			newFee := integralFee
			if coinId == "0" {
				newFee = fee
			}
			ratio := getVirtualCoinRatio(userType, level, peerNum, opt.UserRate, coinId, isPostion)
			amount := getCoinAmount(ratio, zhios_order_relate_utils.StrToInt(coinId), newFee, opt.VirtualCoinMoneyRatioList)
			if coinId != "0" && opt.Mode == "lv_winery" && userType == "own" { //酒庄模式不在这里计算
				amount = 0
			}
			if coinId == "0" {
				commission = amount
			}
			amountList = append(amountList, &VirtualCoinCommission{
				Cid: coinId,
				Val: amount,
			})
			ratioList = append(ratioList, &VirtualCoinCommission{
				Cid: coinId,
				Val: zhios_order_relate_utils.AnyToFloat64(ratio),
			})
		}
	}

	if ownbuyReturnType == 1 { //自购不返利
		commission = 0
		for i := range amountList {
			amountList[i].Val = 0
		}
	}
	commission = zhios_order_relate_utils.FloatFormat(commission, 2)

	for i, coin := range amountList {
		amountList[i].Val = zhios_order_relate_utils.FloatFormat(coin.Val, 6)
	}

	return commission, commissionRatio, amountList, ratioList
}

//公共处理下团队-上一层 （用于旧版的制度 只有佣金时）
func extendDiffMoney(profit float64, payMode, isOnlySubsidy int, totalAmt, restAmt, teamRatio, totalRatio, peerRate, subsidyFee, subsidyRatio float64) (float64, float64, float64, float64, bool) {
	//totalRatio += teamRatio
	//出现负数跳过
	if teamRatio <= 0 {
		profit = 0
		return profit, restAmt, totalRatio, subsidyFee, true
	}
	profit = zhios_order_relate_utils.FloatFormat(teamRatio*totalAmt, 2)
	if restAmt < profit {
		profit = 0
		return profit, restAmt, totalRatio, subsidyFee, true
	}
	restAmt -= profit // 剩余可分
	restAmt = zhios_order_relate_utils.FloatFormat(restAmt, 2)
	return profit, restAmt, totalRatio, subsidyFee, false
}

// 处理多虚拟币团队的
func extendDiffMoneyV2(profitList []*VirtualCoinCommission, payMode, isOnlySubsidy int, totalAmtList, restAmtList, teamRatioList, totalRatioList, peerRateList, subsidyFeeList, subsidyRatioList []*VirtualCoinCommission) (newProfitList, newRestAmtList, newTotalRatioList, newSubsidyFeeList []*VirtualCoinCommission, zeroList map[string]struct{}) {
	restAmtMap := convertList2Map(restAmtList)
	totalAmtMap := convertList2Map(totalAmtList)
	totalRatioMap := convertList2Map(totalRatioList)
	subsidyFeeMap := convertList2Map(subsidyFeeList)
	teamRatioMap := convertList2Map(teamRatioList)

	zeroList = make(map[string]struct{})
	newProfitList = make([]*VirtualCoinCommission, 0)

	for _, coin := range profitList {
		//totalRatioMap[coin.Cid] += teamRatioMap[coin.Cid]
		profitOne := &VirtualCoinCommission{}
		profitOne.Cid = coin.Cid
		profitOne.Val = zhios_order_relate_utils.FloatFormat(totalAmtMap[coin.Cid]*teamRatioMap[coin.Cid], 6)
		// 剩余不足或比例小于0
		if teamRatioMap[coin.Cid] < 0 || restAmtMap[coin.Cid] < profitOne.Val {
			zeroList[coin.Cid] = struct{}{}
			profitOne.Val = 0
		}
		newProfitList = append(newProfitList, profitOne)
		restAmtMap[coin.Cid] -= profitOne.Val

	}
	newTotalRatioList = convertMap2List(totalRatioMap)
	newRestAmtList = convertMap2List(restAmtMap)
	newSubsidyFeeList = convertMap2List(subsidyFeeMap)

	return newProfitList, newRestAmtList, newTotalRatioList, newSubsidyFeeList, zeroList
}
