package md

import "github.com/shopspring/decimal"

var (
	WithdrawalCommissionFee = decimal.NewFromFloat(0.15) //提现手续费比例
	WithdrawalDestroyFee    = decimal.NewFromFloat(0.05) //提现销毁增值积分比例
	WithdrawalRefluxFee     = decimal.NewFromFloat(0.10) //提现回流增值积分比例
)

type DealWithdrawalAndDestroyResp struct {
	Price            float64 `json:"price"`              //价值
	TransferOut      float64 `json:"transfer_out"`       //提现的积分
	TransferOutValue float64 `json:"transfer_out_value"` //提现的余额
	AmountOut        float64 `json:"amount_out"`         //手续费
	DestroyValue     float64 `json:"destroy_value"`      //销毁的积分
	RefluxValue      float64 `json:"reflux_value"`       //回流的积分
}
type DealWithdrawalFeeResp struct {
	WithdrawalCommissionFee float64 `json:"withdrawal_commission_fee"` //提现手续费比例
	WithdrawalDestroyFee    float64 `json:"withdrawal_destroy_fee"`    //提现销毁增值积分比例
	WithdrawalRefluxFee     float64 `json:"withdrawal_reflux_fee"`     //提现回流增值积分比例
}
