package md

// 获取用户的缓存key
const (
	KEY_SYS_CFG_CACHE = "sys_cfg_cache"

	// 文件缓存的key
	KEY_CFG_FILE_PVD              = "file_provider" // 文件供应商
	KEY_CFG_FILE_BUCKET           = "file_bucket"
	KEY_CFG_FILE_REGION           = "file_bucket_region"
	KEY_CFG_FILE_HOST             = "file_bucket_host"
	KEY_CFG_FILE_SCHEME           = "file_bucket_scheme"
	KEY_CFG_FILE_AK               = "file_access_key"
	KEY_CFG_FILE_SK               = "file_secret_key"
	KEY_CFG_FILE_MAX_SIZE         = "file_user_upload_max_size"
	KEY_CFG_FILE_EXT              = "file_ext"
	KEY_CFG_FILE_AVATAR_THUMBNAIL = "file_avatar_thumbnail" // 默认头像缩略图参数,宽高120px,格式webp.
	// 智盟
	KEY_CFG_ZM_JD_SITE_ID = "third_zm_jd_site_id" // 智盟京东联盟id
	KEY_CFG_ZM_WEB_ID     = "third_zm_web_id"     // 智盟网站ID
	KEY_CFG_ZM_AK         = "third_zm_app_key"
	KEY_CFG_ZM_SK         = "third_zm_app_secret"
	KEY_CFG_ZM_SMS_AK     = "third_zm_sms_ak"
	KEY_CFG_ZM_SMS_SK     = "third_zm_sms_sk"
	KEY_CFG_APP_NAME      = "app_name"

	KEY_CFG_WHITELIST = "api_cfg_whitelist" // API允许的访问的设置白名单

	// 淘宝
	KEY_CFG_TB_AUTH_AK      = "third_taobao_auth_ak"
	KEY_CFG_TB_AUTH_SK      = "third_taobao_auth_sk"
	KEY_CFG_TB_INVITER_CODE = "third_taobao_auth_inviter_code"
	KEY_CFG_TB_AK           = "third_taobao_ak"
	KEY_CFG_TB_SK           = "third_taobao_sk"
	KEY_CFG_TB_PID          = "third_taobao_pid" // 淘宝推广ID,如:mm_123_456_789,123是联盟ID,456是site_id,789是adzone_id
	KEY_CFG_TB_SID          = "third_taobao_sid" // 淘宝session id ,又称access_token

	// 苏宁
	KEY_CFG_SN_AK = "third_suning_ak"
	KEY_CFG_SN_SK = "third_suning_sk"

	KEY_CFG_JD_AK = ""
	KEY_CFG_JD_SK = ""

	KEY_CFG_KL_AK = "third_kaola_ak"
	KEY_CFG_KL_SK = "third_kaola_sk"

	KEY_CFG_VIP_AK = ""
	KEY_CFG_VIP_SK = ""

	// 自动任务配置
	KEY_CFG_CRON_TB                      = "cron_order_taobao"
	KEY_CFG_CRON_JD                      = "cron_order_jd"
	KEY_CFG_CRON_PDD                     = "cron_order_pdd"
	KEY_CFG_CRON_SN                      = "cron_order_suning"
	KEY_CFG_CRON_VIP                     = "cron_order_vip"
	KEY_CFG_CRON_KL                      = "cron_order_kaola"
	KEY_CFG_CRON_DUOMAI                  = "cron_order_duomai"
	KEY_CFG_CRON_HIS                     = "cron_order_his"        // 迁移到历史订单
	KEY_CFG_CRON_SETTLE                  = "cron_order_settle"     // 迁移到历史订单
	KEY_CFG_CRON_PUBLISHER               = "cron_taobao_publisher" // 跟踪淘宝备案信息绑定会员运营id 针对小程序
	KEY_CFG_CRON_MEITUAN                 = "cron_order_meituan"    //美团
	KEY_CFG_CRON_OILSTATION              = "cron_order_oilstation" //加油
	KEY_CFG_CRON_KFC                     = "cron_order_kfc"        //肯德基
	KEY_CFG_CRON_CINEMA                  = "cron_order_cinema"     //电影票
	KEY_CFG_CRON_OilRequest              = "cron_order_oilrequest" //加入主动请求抓单
	KEY_CFG_CRON_AGOTB                   = "cron_order_agotaobao"  //n天前的淘宝订单
	KEY_CFG_CRON_CREDIT_CARD             = "cron_order_credit_card"
	KEY_CFG_CRON_ORDER_STAT              = "cron_order_stat"                     // 订单统计任务
	KEY_CFG_CRON_CARD_UPDATE             = "cron_card_update"                    // 权益卡更新
	KEY_CFG_CRON_USER_LV_UP_SETTLE       = "cron_user_lv_up_settle"              //会员费订单结算
	KEY_CFG_CRON_PRIVILEGE_CARD_SETTLE   = "cron_privilege_card_settle"          //权益卡订单结算
	KEY_CFG_CRON_CARD_RETURN             = "cron_card_return"                    //权益卡退款
	KEY_CFG_CRON_PUBLISHER_RELATION      = "cron_taobao_publisher_relation"      //获取淘宝渠道
	KEY_CFG_CRON_DTKBRAND                = "cron_dtk_brand"                      //大淘客品牌信息
	KEY_CFG_CRON_PUBLISHER_RELATION_BIND = "cron_taobao_publisher_relation_bind" //获取淘宝渠道绑定

	// 自动任务运行时设置
	KEY_CFG_CRON_TIME_TB         = "crontab_order_time_taobao"
	KEY_CFG_CRON_TIME_JD         = "crontab_order_time_jd"
	KEY_CFG_CRON_TIME_PDD        = "crontab_order_time_pdd"
	KEY_CFG_CRON_TIME_SN         = "crontab_order_time_suning"
	KEY_CFG_CRON_TIME_VIP        = "crontab_order_time_vip"
	KEY_CFG_CRON_TIME_KL         = "crontab_order_time_kaola"
	KEY_CFG_CRON_TIME_DUOMAI     = "crontab_order_time_duomai"
	KEY_CFG_CRON_TIME_PUBLISHER  = "crontab_taobao_time_publisher" // 跟踪淘宝备案信息绑定会员运营id 针对小程序
	KEY_CFG_CRON_TIME_MEITUAN    = "crontab_order_time_meituan"    //美团
	KEY_CFG_CRON_TIME_OILSTATION = "crontab_order_time_oilstation" //加油
	KEY_CFG_CRON_TIME_KFC        = "crontab_order_time_kfc"        //肯德基
	KEY_CFG_CRON_TIME_CINEMA     = "crontab_order_time_cinema"     //电影票

)
