package md

// 公排结构
type SmallLvGrade struct {
	Lv                 int               `json:"lv"`                   // 会员级别
	LvName             string            `json:"lv_name"`              // 会员名称
	ReturnType         []string          `json:"return_type"`          //返利类型
	CommonWealthSystem map[string]string `json:"common_wealth_system"` //共富制度比例
	SelfRateList       map[string]string `json:"self_rate_list"`       // 自购比例
	DirectPush         map[string]string `json:"direct_push"`          // 直推奖励比例
}

type SmallPublicPlatoonRelateCommissionReq struct {
	Pvd             string `json:"pvd"` //平台供应商 (taobao/jd/pdd/mall_goods ...)
	Uid             string `json:"uid"`
	UserLevel       string `json:"user_level"`       //用户等级
	PendingAmount   string `json:"pending_amount"`   //待处理金额
	Oid             string `json:"oid"`              //订单id
	PendingIntegral string `json:"pending_integral"` //待处理金额
}

type SmallPublicPlatoonRelateCommissionResp struct {
	Uid                    string            `json:"uid"`
	CommonWealthBenefitUid string            `json:"common_wealth_benefit_uid"` //共富奖励给到的uid
	DirectPushBenefitUid   string            `json:"direct_push_benefit_uid"`   //直推奖励给到的uid
	PendingAmount          string            `json:"pending_amount"`            //处理金额
	Oid                    string            `json:"oid"`
	SelfRateList           map[string]string `json:"self_rate_list"`       // 自购奖励
	CommonWealthSystem     map[string]string `json:"common_wealth_system"` // 共富制度奖励
	DirectPush             map[string]string `json:"direct_push"`          // 直推奖励
	PendingIntegral        string            `json:"pending_integral"`     //待处理金额
}

type CalcSmallPublicPlatoonRelateLaXinReward struct {
	Uid    string `json:"uid"`
	CoinId int    `json:"coin_id"`
	Value  string `json:"value"`
}
type CalcSmallPublicPlatoonRelateLaXinLevel struct {
	Id     string                                     `json:"id"`
	Detail []*CalcSmallPublicPlatoonRelateLaXinDetail `json:"detail"`
}

type CalcSmallPublicPlatoonRelateLaXinDetail struct {
	Key int         `json:"key"`
	Val interface{} `json:"val"`
}

type SmallAddPublicPlatoonRelateCommissionReq struct {
	Uid          string `json:"uid"`
	RecommendUid string `json:"recommend_uid"` //推荐人uid
}

type StandardSmallPublicPlatoonRelation struct {
	FatherUid1 int `json:"father_uid1"`
	FatherUid2 int `json:"father_uid2"`
	FatherUid3 int `json:"father_uid3"`
	FatherUid4 int `json:"father_uid4"`
	FatherUid5 int `json:"father_uid5"`
	FatherUid6 int `json:"father_uid6"`
	FatherUid7 int `json:"father_uid7"`
	FatherUid8 int `json:"father_uid8"`
	FatherUid9 int `json:"father_uid9"`
	Pid1       int `json:"pid1"`
	Pid2       int `json:"pid2"`
	Pid3       int `json:"pid3"`
	Pid4       int `json:"pid4"`
	Pid5       int `json:"pid5"`
	Pid6       int `json:"pid6"`
	Pid7       int `json:"pid7"`
	Pid8       int `json:"pid8"`
	Pid9       int `json:"pid9"`
	Position1  int `json:"position1"`
	Position2  int `json:"position2"`
	Position3  int `json:"position3"`
	Position4  int `json:"position4"`
	Position5  int `json:"position5"`
	Position6  int `json:"position6"`
	Position7  int `json:"position7"`
	Position8  int `json:"position8"`
	Position9  int `json:"position9"`
	Level1     int `json:"level1"`
	Level2     int `json:"level2"`
	Level3     int `json:"level3"`
	Level4     int `json:"level4"`
	Level5     int `json:"level5"`
	Level6     int `json:"level6"`
	Level7     int `json:"level7"`
	Level8     int `json:"level8"`
	Level9     int `json:"level9"`
	LevelTotal int `json:"level_total"`
}
