package rule

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	"time"
	"xorm.io/xorm"
)

//共富收益
func PublicPlatoonSettle(session *xorm.Session, ItemTitle, ordId string, uid, coinId int, amount float64) bool {
	now := time.Now()
	var data model.UserPublicPlatoonAmount
	has, err := session.Where("uid=? and coin_id=?", uid, coinId).Get(&data)
	if err != nil {
		return false
	}
	beforeAmount := "0"
	if has == false {
		data = model.UserPublicPlatoonAmount{
			Uid:    uid,
			CoinId: coinId,
			Amount: zhios_order_relate_utils.AnyToString(amount),
		}
		_, err := session.Insert(&data)
		if err != nil {
			return false
		}
	} else {
		beforeAmount = data.Amount
		data.Amount = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(data.Amount)+amount, 6)
		_, err := session.Where("id=?", data.Id).Cols("amount").Update(&data)
		if err != nil {
			return false
		}
	}
	finUserFlow := model.UserPublicPlatoonIncomeRecords{
		Type:         0,
		Uid:          uid,
		Amount:       zhios_order_relate_utils.AnyToString(amount),
		CreateAt:     now,
		UpdateAt:     now,
		Date:         now.Format("2006-01"),
		Kind:         3,
		CoinId:       coinId,
		Title:        ItemTitle,
		BeforeAmount: beforeAmount,
		Oid:          ordId,
	}
	_, err = session.Insert(&finUserFlow)
	if err != nil {
		return false
	}
	return true
}
func PublicPlatoonAddRecord(eg *xorm.Engine, ItemTitle, ordId string, uid, coinId, kind, types int, amount float64, beforeAmount string) bool {
	now := time.Now()

	finUserFlow := model.UserPublicPlatoonIncomeRecords{
		Type:         types,
		Uid:          uid,
		Amount:       zhios_order_relate_utils.AnyToString(amount),
		CreateAt:     now,
		UpdateAt:     now,
		Date:         now.Format("2006-01"),
		Kind:         kind,
		CoinId:       coinId,
		Title:        ItemTitle,
		BeforeAmount: beforeAmount,
		Oid:          ordId,
	}
	_, err := eg.Insert(&finUserFlow)
	if err != nil {
		return false
	}
	return true
}
func PublicPlatoonAddRecordWithSession(session *xorm.Session, ItemTitle, ordId string, uid, coinId, kind, types int, amount float64, beforeAmount string) bool {
	now := time.Now()

	finUserFlow := model.UserPublicPlatoonIncomeRecords{
		Type:         types,
		Uid:          uid,
		Amount:       zhios_order_relate_utils.AnyToString(amount),
		CreateAt:     now,
		UpdateAt:     now,
		Date:         now.Format("2006-01"),
		Kind:         kind,
		CoinId:       coinId,
		Title:        ItemTitle,
		BeforeAmount: beforeAmount,
		Oid:          ordId,
	}
	_, err := session.Insert(&finUserFlow)
	if err != nil {
		return false
	}
	return true
}
