package rule

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	"encoding/json"
	"fmt"
	"time"
	"xorm.io/xorm"
)

func BindUserOrdToSubAgent(eg *xorm.Engine, dbName string, data *md.InsertRegionalAgentOrdBelongData) {
	CommRegionalSubAgentInsert(eg, data)
}

//公共调用
func CommRegionalSubAgentInsert(engine *xorm.Engine, args *md.InsertRegionalAgentOrdBelongData) int {
	res, userBelong := InsertRegionalSubAgentOrdBelong(engine, args)
	if !res {
		return 0
	}
	//todo::调用 “计算制度” 方法
	_, res = HandleSubCommissionDistributionSystem(engine, &md.RegionalAgentSystemArgs{
		Uid:      zhios_order_relate_utils.AnyToString(args.Uid),
		Amount:   args.Commission,
		OrdId:    zhios_order_relate_utils.AnyToString(args.OrderId),
		Pvd:      args.Pvd,
		CommPvd:  args.CommPvd,
		Status:   args.Status,
		Type:     "2",
		RegionId: zhios_order_relate_utils.AnyToString(userBelong.RegionId),
	})
	if !res {
		return 2
	}
	return 1
}

func HandleSubCommissionDistributionSystem(engine *xorm.Engine, args *md.RegionalAgentSystemArgs) ([]map[string]interface{}, bool) {
	amount := zhios_order_relate_utils.AnyToFloat64(args.Amount)
	var regionId string
	if args.Type == "1" {
		//获取当前用户的 归属
		userBelong, err := db.GetCountByRegionalAgentUserBelongById(engine, args.Uid, args.Pvd, args.CommPvd)
		fmt.Println(err)
		fmt.Println(userBelong)
		if err != nil || userBelong == nil {
			return nil, false
		}
		regionId = zhios_order_relate_utils.AnyToString(userBelong.RegionId)
	} else {
		regionId = args.RegionId
	}

	//查询用户所属 “代理网点”  信息
	regionalAgentRegion, err := db.RegionalAgentRegionGetOneByParams(engine, map[string]interface{}{
		"key":   "id",
		"value": zhios_order_relate_utils.AnyToInt64(regionId),
	})
	if err != nil {
		return nil, false
	}
	if regionalAgentRegion == nil {
		return nil, true
	}
	//查询 regional_agent_base 表获取虚拟币相关配置信息
	agentBase, err := db.GetCountByRegionalAgentBase(engine)
	if err != nil {
		return nil, false
	}
	var coinSet = md.CoinSet{}
	err = json.Unmarshal([]byte(agentBase.CoinSet), &coinSet)
	if err != nil {
		return nil, false
	}

	//查询 virtual_coin 获取虚拟货币的 “兑换比例”
	virtualCoin, err := db.VirtualCoinFindByParams(engine, map[string]interface{}{})
	if err != nil {
		return nil, false
	}
	var virtualCoinMap = map[int]string{}
	for _, v := range *virtualCoin {
		virtualCoinMap[v.Id] = v.ExchangeRatio
	}
	//查询代理网点的代理（网点、区、市、省）信息
	var parents, tempParents []map[string]interface{}
	//tempParents, amount, _, err = makeSubSystemData(engine, regionalAgentRegion, &coinSet, virtualCoinMap, parents, amount, md.SITE)
	//if err != nil {
	//	return nil, false
	//}
	//if tempParents != nil {
	//	parents = tempParents
	//}
	//
	//tempParents, amount, _, err = makeSubSystemData(engine, regionalAgentRegion, &coinSet, virtualCoinMap, parents, amount, md.COUNTRY)
	//if err != nil {
	//	return nil, false
	//}
	//if tempParents != nil {
	//	parents = tempParents
	//}

	tempParents, amount, _, err = makeSubSystemData(engine, args, regionalAgentRegion, &coinSet, virtualCoinMap, parents, amount, md.COUNTRY)
	if err != nil {
		return nil, false
	}
	if tempParents != nil {
		parents = tempParents
	}

	//tempParents, amount, _, err = makeSubSystemData(engine, regionalAgentRegion, &coinSet, virtualCoinMap, parents, amount, md.PROVINCE)
	//if err != nil {
	//	return nil, false
	//}
	//if tempParents != nil {
	//	parents = tempParents
	//}

	fmt.Println("区域代理")
	fmt.Println(parents)

	for _, v := range parents {
		var divideVirtualCurrency = ""
		if !zhios_order_relate_utils.IsNil(v["divide_virtual_currency"]) {
			jsonStr, err := json.Marshal(v["divide_virtual_currency"])
			if err != nil {
				fmt.Println("虚拟币查询")
				fmt.Println(err)
				return nil, false
			}
			divideVirtualCurrency = string(jsonStr)
		}
		status := 1
		if args.Status == "0" { //导购的一开始不用返的 导购结算才返
			status = 0
		}
		var insertData = model.RegionalSubAgentCalcSystemRelate{
			Uid:                   v["uid"].(int),
			DivideAmount:          zhios_order_relate_utils.AnyToFloat64(v["divide_amount"]),
			DivideVirtualCurrency: divideVirtualCurrency,
			BelongOrdId:           args.OrdId,
			Pvd:                   args.Pvd,
			Status:                status,
			Type:                  zhios_order_relate_utils.StrToInt(args.Type),
			CreatedAt:             time.Now(),
			UpdatedAt:             time.Now(),
		}
		_, err := db.RegionalSubAgentCalcSystemRelateInsert(engine, &insertData)
		if err != nil {
			return nil, false
		}
	}
	return parents, true
}

func makeSubSystemData(engine *xorm.Engine, args *md.RegionalAgentSystemArgs, regionalAgentRegion *model.RegionalAgentRegion, coinSet *md.CoinSet, virtualCoin map[int]string, parents []map[string]interface{}, amount float64, level string) ([]map[string]interface{}, float64, float64, error) {
	var value string
	coinSetDetail := coinSet.SiteAgent
	if regionalAgentRegion.Level == md.CountryKey {
		switch level {
		case md.PROVINCE:
			value = zhios_order_relate_utils.AnyToString(regionalAgentRegion.ProvinceId)
			break
		case md.CITY:
			value = zhios_order_relate_utils.AnyToString(regionalAgentRegion.CityId)
			break
		case md.COUNTRY:
			value = zhios_order_relate_utils.AnyToString(regionalAgentRegion.Id)
			break
		case md.SITE:
			value = zhios_order_relate_utils.AnyToString(0)
			break
		}
		//获得虚拟币的比例
		coinSetDetail = coinSet.DistrictAgent
	}
	fmt.Println("地区ID:", value)
	fmt.Println("余额：", amount)
	if value == "0" {
		return nil, amount, 0, nil
	}

	//查询代理地区
	regionalAgentRegionData, err := db.RegionalAgentRegionGetOneByParams(engine, map[string]interface{}{
		"key":   "id",
		"value": value,
	})
	if regionalAgentRegionData == nil {
		return nil, amount, 0, nil
	}
	//查询代理地区用户
	agentUser, err := db.RegionalSubAgentUserFindByValid(engine, value)
	if err != nil || agentUser == nil {
		return nil, amount, 0, err
	}
	var divideAmount float64 = 0
	//查询对应的等级方案
	scheme, err := db.GetCountByRegionalAgentSchemeInfoByParams(engine, map[string]interface{}{
		"key":   "agent_type",
		"value": regionalAgentRegionData.Level,
	})
	if scheme == nil || err != nil {
		return nil, amount, 0, err
	}
	var commissionRate string
	if scheme.IsUnify == 1 {
		commissionRate = regionalAgentRegionData.SubCommissionRate
	} else {
		commissionRate = scheme.SubUnifyCommissionRate
	}
	parentUser, _ := db.UserProfileFindByID(engine, args.Uid)
	parentUid := 0
	if parentUser != nil {
		parentUid = parentUser.ParentUid
	}
	parents, amount, divideAmount, err = SubCommAmount(parentUid, zhios_order_relate_utils.AnyToFloat64(commissionRate), amount, agentUser, coinSetDetail, virtualCoin, parents, false)
	if err != nil {
		return nil, amount, 0, err
	}
	return parents, amount, divideAmount, nil

}

//公共处理佣金
func SubCommAmount(parentUid int, CommissionRate float64, amount float64, agentUser *[]model.RegionalAgentSubUser, coinSetDetail []md.CoinSetDetail, virtualCoin map[int]string, parents []map[string]interface{}, isTest bool) ([]map[string]interface{}, float64, float64, error) {

	var divideAmount float64 = 0
	if amount == 0 {
		for _, v := range *agentUser {
			var temp = map[string]interface{}{}
			temp["uid"] = v.Uid
			temp["divide"] = 0
			parents = append(parents, temp)
		}
	} else {
		isParent := 0
		for _, v := range *agentUser {
			if v.Uid == parentUid {
				isParent = 1
			}
		}
		rate := CommissionRate / 100
		fmt.Println("比例：", rate)
		divideAmount = rate * amount
		personNum := len(*agentUser)
		if isParent == 1 {
			personNum = 1
		}
		fmt.Println("人数：", personNum)
		if personNum == 0 && isTest == false {
			return nil, amount, divideAmount, nil
		}
		everyPersonDivideAmount := divideAmount / zhios_order_relate_utils.AnyToFloat64(personNum)
		for _, v := range *agentUser {
			if v.Uid != parentUid && isParent == 1 {
				continue
			}
			var temp = map[string]interface{}{}
			temp["uid"] = v.Uid
			if amount == 0 {
				temp["divide_amount"] = 0
			} else {
				temp["divide_amount"] = everyPersonDivideAmount
				var coinSetDetailMap []map[string]interface{}
				for _, v := range coinSetDetail {
					var exchangeRatio float64
					if zhios_order_relate_utils.AnyToFloat64(virtualCoin[v.CoinID]) != 0 {
						exchangeRatio = zhios_order_relate_utils.AnyToFloat64(virtualCoin[v.CoinID])
					} else {
						exchangeRatio = 0
					}
					coinSetDetailMap = append(coinSetDetailMap, map[string]interface{}{
						"coin_id":      v.CoinID,
						"coin_name":    v.CoinName,
						"divide_value": zhios_order_relate_utils.AnyToFloat64(temp["divide_amount"]) * (zhios_order_relate_utils.AnyToFloat64(v.Value) / 100) * exchangeRatio,
					})
				}
				temp["divide_virtual_currency"] = coinSetDetailMap
			}
			parents = append(parents, temp)
		}
		if amount-divideAmount <= 0 {
			amount = 0
		} else {
			amount = amount - divideAmount
		}
	}
	return parents, amount, divideAmount, nil
}

//InsertRegionalAgentOrdBelong 插入 regional_agent_ord_belong (用户订单归属表) 数据
func InsertRegionalSubAgentOrdBelong(engine *xorm.Engine, data *md.InsertRegionalAgentOrdBelongData) (bool, *model.RegionalAgentUserBelong) {
	// 查询 regional_agent_user_belong 得到用户归属的区域代理
	userBelong, err := db.GetCountByRegionalAgentUserBelongById(engine, data.Uid, data.Pvd, data.CommPvd)

	if err != nil || userBelong == nil {
		return false, nil
	}
	date := time.Now()
	_, err = db.RegionalSubAgentOrdBelongInsert(engine, &model.RegionalSubAgentOrdBelong{
		Uid:          int(zhios_order_relate_utils.AnyToInt64(data.Uid)),
		Pvd:          data.Pvd,
		OrderId:      data.OrderId,
		CurrencyType: 1,
		Commission:   data.Commission,
		RegionId:     userBelong.RegionId,
		RegionalName: userBelong.RegionalName,
		ProvinceId:   userBelong.ProvinceId,
		CityId:       userBelong.CityId,
		DistrictId:   userBelong.DistrictId,
		SiteId:       userBelong.SiteId,
		CreateTime:   date,
		UpdateTime:   date,
		Level:        userBelong.Level,
	})
	if err != nil {
		return false, nil
	}

	return true, userBelong
}
