package svc

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/lib/comm_plan"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	"encoding/json"
	"xorm.io/xorm"
)

func ExtendPriceReward(eg *xorm.Engine, param map[string]string, cfg *comm_plan.PlanOpt) (map[string]string, int) {
	if zhios_order_relate_utils.InArr(param["source"], []string{"mall_goods_extend_price", "regional_agent_pay"}) == false {
		return map[string]string{"0": "0"}, 0
	}
	commissionOpt, err := db.DbsPlanCommissionById(eg, cfg.PlanCommissionId)
	if err != nil || commissionOpt == nil || commissionOpt.Id == 0 {
		return map[string]string{"0": "0"}, 0
	}
	var subsidyTmp = make(map[int]*md.ExtendRewardLvGrade)
	var tmp map[int]*md.ExtendRewardLvGrade
	if err := json.Unmarshal([]byte(commissionOpt.Data), &tmp); err != nil {
		return map[string]string{"0": "0"}, 0
	}
	for _, v := range tmp {
		subsidyTmp[v.Lv] = v
	}
	userProfile, err := db.UserProfileFindByID(eg, param["uid"])
	if err != nil || userProfile == nil {
		return map[string]string{"0": "0"}, 0
	}
	if userProfile.ParentUid == 0 {
		return map[string]string{"0": "0"}, 0
	}
	//查询用户等级
	parentUser, err := db.UserFindByID(eg, userProfile.ParentUid)
	if err != nil || parentUser == nil {
		return map[string]string{"0": "0"}, 0
	}
	lvGrade := subsidyTmp[parentUser.Level]
	var rewardList = make(map[string]md.ExtendPriceRewardListDetail)
	if param["source"] == "mall_goods_extend_price" {
		rewardList = lvGrade.ExtendPriceRewardUpLv
	}
	if param["source"] == "regional_agent_pay" {
		if param["level"] == "1" {
			rewardList = lvGrade.ExtendPriceRewardProvince
		}
		if param["level"] == "2" {
			rewardList = lvGrade.ExtendPriceRewardCity
		}
		if param["level"] == "3" {
			rewardList = lvGrade.ExtendPriceRewardArea
		}
		if param["level"] == "4" {
			rewardList = lvGrade.ExtendPriceRewardSite
		}
	}
	//查出当前的数量
	count, _ := eg.Where("source=? and lv=? and parent_uid=?", param["source"], param["level"], userProfile.ParentUid).Count(&model.UserLvBuyList{})
	count++
	var isTrue = false
	//如果等级一致 或是代理费分佣 判断位置
	if param["source"] == "mall_goods_extend_price" || param["source"] == "regional_agent_pay" {
		isTrue = true
	}
	var extendReward = make(map[string]string)
	if lvGrade != nil {

		for _, coinId := range lvGrade.ReturnType {
			reward := rewardList[coinId]
			var pendingAmount = param["commission"]
			if zhios_order_relate_utils.StrToInt(coinId) > 0 { //积分更换基数
				pendingAmount = param["integral"]
			}
			rewardAmount := reward.Bili
			//如果等级一致 判断位置
			if isTrue && zhios_order_relate_utils.StrToInt(reward.BaseVal) > 0 {
				position := count % zhios_order_relate_utils.StrToInt64(reward.BaseVal)
				if position == 0 {
					rewardAmount = reward.PositionBili
				}
			}

			extendReward[coinId] = zhios_order_relate_utils.Float64ToStr(zhios_order_relate_utils.StrToFloat64(rewardAmount) * zhios_order_relate_utils.StrToFloat64(pendingAmount) / 100)
		}
	}

	return extendReward, userProfile.ParentUid
}
