package svc

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"encoding/json"
	"errors"
	"fmt"
	"strconv"
	"strings"
	"xorm.io/xorm"
)

// 批量分佣 订单显示
func BatchSmallGetPublicPlatoonRelateCommission(engine *xorm.Engine, masterId string, PublicPlatoonRelateCommissionReqList []*md.SmallPublicPlatoonRelateCommissionReq) (map[string]*md.SmallPublicPlatoonRelateCommissionResp, error) {
	var resp = make(map[string]*md.SmallPublicPlatoonRelateCommissionResp)
	for _, param := range PublicPlatoonRelateCommissionReqList {
		// 根据供应商
		rewardOpt, err := db.DbsPlanRewardByPvd(engine, param.Pvd)
		if err != nil {
			return nil, err
		}
		if rewardOpt == nil {
			return nil, zhios_order_relate_logx.Warn("找不到方案记录")
		}
		if rewardOpt.State == 0 {
			return nil, zhios_order_relate_logx.Warn("抽成方案未开启")
		}
		if rewardOpt.PlanCommissionId == 0 {
			return nil, zhios_order_relate_logx.Warn("抽成方案未设置佣金方案id")
		}
		fmt.Println("抽成设置:", zhios_order_relate_utils.SerializeStr(rewardOpt))
		fmt.Println("commission id:", rewardOpt.PlanCommissionId)

		//TODO::计算共富收益
		commissionOpt, err := db.DbsPlanCommissionById(engine, rewardOpt.PlanCommissionId)
		if err != nil || commissionOpt == nil || commissionOpt.Id == 0 {
			return nil, err
		}
		var subsidyTmp = make(map[string]*md.LvGrade)
		var tmp map[string]*md.LvGrade
		if err := json.Unmarshal([]byte(commissionOpt.Data), &tmp); err != nil {
			return nil, zhios_order_relate_logx.Warn(fmt.Sprintf("%s:分佣方案数据设置错误", masterId))
		}
		for _, v := range tmp {
			subsidyTmp[zhios_order_relate_utils.IntToStr(v.Lv)] = v
		}
		lvGrade := subsidyTmp[param.UserLevel]
		var directPush = make(map[string]string)
		var selfRateList = make(map[string]string)
		var commonWealthSystem = make(map[string]string)
		if lvGrade != nil {
			for _, coinId := range lvGrade.ReturnType {
				var pendingAmount = param.PendingAmount
				if zhios_order_relate_utils.StrToInt(coinId) > 0 { //积分更换基数
					pendingAmount = param.PendingIntegral
				}
				selfRateList[coinId] = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(lvGrade.SelfRateList[coinId])*zhios_order_relate_utils.StrToFloat64(pendingAmount)/100, 9)
				commonWealthSystem[coinId] = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(lvGrade.CommonWealthSystem[coinId])*zhios_order_relate_utils.StrToFloat64(pendingAmount)/100, 9)
				directPush[coinId] = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(lvGrade.DirectPush[coinId])*zhios_order_relate_utils.StrToFloat64(pendingAmount)/100, 9)
			}
		}

		//TODO::本次消费产生的共富收益给到谁
		nowBenefitUid, _, err := benefitUid(engine, param)
		if err != nil {
			return nil, err
		}
		recommendUid := ""
		userProfile, _ := db.UserProfileFindByID(engine, param.Uid)
		if userProfile != nil && userProfile.ParentUid > 0 {
			recommendUid = zhios_order_relate_utils.IntToStr(userProfile.ParentUid)
		}
		resp[param.Oid] = &md.SmallPublicPlatoonRelateCommissionResp{
			Uid:                    param.Uid,
			CommonWealthBenefitUid: nowBenefitUid,
			DirectPushBenefitUid:   recommendUid,
			PendingAmount:          param.PendingAmount,
			Oid:                    param.Oid,
			SelfRateList:           selfRateList,
			CommonWealthSystem:     commonWealthSystem,
			DirectPush:             directPush,
		}
	}
	return resp, nil
}
func benefitUid(engine *xorm.Engine, param *md.SmallPublicPlatoonRelateCommissionReq) (string, map[string]*md.SmallPublicPlatoonRelateCommissionResp, error) {
	var nowBenefitUid string
	userPublicPlatoonRelation, err := db.UserSmallPublicPlatoonRelationGetOneByParams(engine, map[string]interface{}{
		"key":   "uid",
		"value": param.Uid,
	})
	if err != nil {
		return nowBenefitUid, nil, err
	}
	if userPublicPlatoonRelation == nil {
		return nowBenefitUid, nil, errors.New("未查询到公排关系记录")
	}
	if userPublicPlatoonRelation.FatherUid == "" {
		//TODO::原始创始人
		nowBenefitUid = ""
	} else {
		fatherPositions := strings.Split(userPublicPlatoonRelation.FatherUid, "-")
		var fatherPosition string
		userPublicPlatoonRelation.ReturnCommissionNum++
		userPublicPlatoonSetting, err := db.UserPublicPlatoonSettingGetOneByParams(engine, map[string]interface{}{
			"key":   "is_open",
			"value": 1,
		})
		if len(fatherPositions) > userPublicPlatoonSetting.SeveralRows {
			remainder1 := (userPublicPlatoonRelation.ReturnCommissionNum) % userPublicPlatoonSetting.SeveralRows
			if remainder1 == 0 {
				fatherPosition = fatherPositions[userPublicPlatoonSetting.SeveralRows-1]
			} else {
				fatherPosition = fatherPositions[remainder1-1]
			}
		} else {
			remainder1 := (userPublicPlatoonRelation.ReturnCommissionNum) % len(fatherPositions)
			if remainder1 == 0 {
				fatherPosition = fatherPositions[len(fatherPositions)-1]
			} else {
				fatherPosition = fatherPositions[remainder1-1]
			}
		}

		nowBenefitUsers, err := db.UserSmallPublicPlatoonRelationGetOneByParams(engine, map[string]interface{}{
			"key":   "id",
			"value": fatherPosition,
		})
		if err != nil {
			return nowBenefitUid, nil, err
		}
		if nowBenefitUsers == nil {
			//未查询到父级公排关系记录
			nowBenefitUid = ""
			//return nil, errors.New("未查询到父级公排关系记录")
		} else {
			if nowBenefitUsers.Uid == -1 || nowBenefitUsers.Uid == -2 {
				//则为待填充空位用户
				nowBenefitUid = ""
			} else {
				nowBenefitUid = zhios_order_relate_utils.AnyToString(nowBenefitUsers.Uid)
			}
		}

		//TODO::更新 公排关系记录 中 `return_commission_num`
		affected, err := db.UserSmallPublicPlatoonRelationUpdate(engine.NewSession(), userPublicPlatoonRelation.Id, userPublicPlatoonRelation, "return_commission_num")
		if err != nil {
			return nowBenefitUid, nil, err
		}
		if affected == 0 {
			return nowBenefitUid, nil, errors.New("更新公排关系记录失败")
		}
	}
	return nowBenefitUid, nil, nil

}

func CalcSmallPublicPlatoonRelateLaXinReward(engine *xorm.Engine, masterId string, rewardUid, level int) (resp []*md.CalcSmallPublicPlatoonRelateLaXinReward, err error) {
	userPublicPlatoonRelation, err := db.UserSmallPublicPlatoonRelationGetOneByParams(engine, map[string]interface{}{
		"key":   "uid",
		"value": rewardUid,
	})
	if err != nil {
		return nil, err
	}
	if userPublicPlatoonRelation == nil {
		return nil, errors.New("未查询到公排关系记录")
	}
	if userPublicPlatoonRelation.FatherUid == "" {
		//TODO::原始创始人
		return
	} else {
		//1、查询 user_public_platoon_laxin_reward_setting
		var m model.UserPublicPlatoonLaxinRewardSetting
		has, err1 := engine.Where("id >= 1").Get(&m)
		if err1 != nil {
			return nil, zhios_order_relate_logx.Error(err1)
		}
		if has == false {
			return
		}
		if m.IsUse == 0 {
			return
		}

		//2、解析 detail
		var detail []*md.CalcSmallPublicPlatoonRelateLaXinDetail
		if err2 := json.Unmarshal([]byte(m.Detail), &detail); err2 != nil {
			return nil, err2
		}

		var levelDetail []md.CalcSmallPublicPlatoonRelateLaXinLevel
		err2 := json.Unmarshal([]byte(m.LevelDetail), &levelDetail)
		if err2 == nil {
			for _, v := range levelDetail {
				if zhios_order_relate_utils.StrToInt(v.Id) == level && len(v.Detail) > 0 {
					detail = v.Detail
				}
			}
		}
		fatherPositions := strings.Split(userPublicPlatoonRelation.FatherUid, "-")
		var rewardUserLevelWeight int
		if m.IsUseRewardLimit == 1 {
			//3、判断是否开启奖励限制
			rewardUser, err3 := db.UserFindByID(engine, rewardUid)
			if err3 != nil {
				return nil, err3
			}

			rewardUserLevel, err4 := db.UserLevelByID(engine, rewardUser.Level)
			if err4 != nil {
				return nil, err4
			}
			if rewardUserLevel == nil {
				return nil, errors.New("未查询到对应等级")
			}
			rewardUserLevelWeight = rewardUserLevel.LevelWeight
		}

		for k, v := range fatherPositions {
			if k >= len(detail) {
				continue
			}
			if m.IsUseRewardLimit == 1 {
				//查询对应用户的等级
				tmpUser, err3 := db.UserFindByID(engine, v)
				if err3 != nil {
					return nil, err3
				}

				tmpUserLevel, err4 := db.UserLevelByID(engine, tmpUser.Level)
				if err4 != nil {
					return nil, err4
				}
				if tmpUserLevel == nil {
					return nil, errors.New("未查询到奖励用户对应等级")
				}
				if tmpUserLevel.LevelWeight < rewardUserLevelWeight {
					//奖励人等级小于
					continue
				}
			}
			value, _ := zhios_order_relate_utils.InterfaceToString(detail[k].Val)
			var uid int
			switch k {
			case 0:
				uid = userPublicPlatoonRelation.FatherUid1
				break
			case 1:
				uid = userPublicPlatoonRelation.FatherUid2
				break
			case 2:
				uid = userPublicPlatoonRelation.FatherUid3
				break
			case 3:
				uid = userPublicPlatoonRelation.FatherUid4
				break
			case 4:
				uid = userPublicPlatoonRelation.FatherUid5
				break
			case 5:
				uid = userPublicPlatoonRelation.FatherUid6
				break
			case 6:
				uid = userPublicPlatoonRelation.FatherUid7
				break
			case 7:
				uid = userPublicPlatoonRelation.FatherUid8
				break
			case 8:
				uid = userPublicPlatoonRelation.FatherUid9
				break
			}

			if uid <= 0 {
				//TODO::不需要讲理
				continue
			}

			tmp := md.CalcSmallPublicPlatoonRelateLaXinReward{
				Uid:    strconv.Itoa(uid),
				CoinId: m.CoinId,
				Value:  value,
			}
			resp = append(resp, &tmp)
		}
	}
	zhios_order_relate_utils.FilePutContents("CalcSmallPublicPlatoonRelateLaXinReward", zhios_order_relate_utils.SerializeStr(map[string]interface{}{
		"masterId":  masterId,
		"rewardUid": rewardUid,
		"resp":      resp,
	}))
	return resp, nil
}

func BatchSmallGetPublicPlatoonRelateByGoods(engine *xorm.Engine, masterId string, PublicPlatoonRelateCommissionReqList []*md.SmallPublicPlatoonRelateCommissionReq) (map[string]*md.SmallPublicPlatoonRelateCommissionResp, error) {
	var resp = make(map[string]*md.SmallPublicPlatoonRelateCommissionResp)
	for _, param := range PublicPlatoonRelateCommissionReqList {
		// 根据供应商
		rewardOpt, err := db.DbsPlanRewardByPvd(engine, param.Pvd)
		if err != nil {
			return nil, err
		}
		if rewardOpt == nil {
			return nil, zhios_order_relate_logx.Warn("找不到方案记录")
		}
		if rewardOpt.State == 0 {
			return nil, zhios_order_relate_logx.Warn("抽成方案未开启")
		}
		if rewardOpt.PlanCommissionId == 0 {
			return nil, zhios_order_relate_logx.Warn("抽成方案未设置佣金方案id")
		}
		fmt.Println("抽成设置:", zhios_order_relate_utils.SerializeStr(rewardOpt))
		fmt.Println("commission id:", rewardOpt.PlanCommissionId)

		//TODO::计算共富收益
		commissionOpt, err := db.DbsPlanCommissionById(engine, rewardOpt.PlanCommissionId)
		if err != nil || commissionOpt == nil || commissionOpt.Id == 0 {
			return nil, err
		}
		var subsidyTmp = make(map[string]*md.LvGrade)
		var tmp map[string]*md.LvGrade
		if err := json.Unmarshal([]byte(commissionOpt.Data), &tmp); err != nil {
			return nil, zhios_order_relate_logx.Warn(fmt.Sprintf("%s:分佣方案数据设置错误", masterId))
		}
		for _, v := range tmp {
			subsidyTmp[zhios_order_relate_utils.IntToStr(v.Lv)] = v
		}
		lvGrade := subsidyTmp[param.UserLevel]
		var directPush = make(map[string]string)
		var selfRateList = make(map[string]string)
		var commonWealthSystem = make(map[string]string)
		if lvGrade != nil {
			for _, coinId := range lvGrade.ReturnType {
				var pendingAmount = param.PendingAmount
				if zhios_order_relate_utils.StrToInt(coinId) > 0 { //积分更换基数
					pendingAmount = param.PendingIntegral
				}
				selfRateList[coinId] = zhios_order_relate_utils.Float64ToStr(zhios_order_relate_utils.StrToFloat64(lvGrade.SelfRateList[coinId]) * zhios_order_relate_utils.StrToFloat64(pendingAmount) / 100)
				commonWealthSystem[coinId] = zhios_order_relate_utils.Float64ToStr(zhios_order_relate_utils.StrToFloat64(lvGrade.CommonWealthSystem[coinId]) * zhios_order_relate_utils.StrToFloat64(pendingAmount) / 100)
				directPush[coinId] = zhios_order_relate_utils.Float64ToStr(zhios_order_relate_utils.StrToFloat64(lvGrade.DirectPush[coinId]) * zhios_order_relate_utils.StrToFloat64(pendingAmount) / 100)
			}
		}
		resp[param.Oid] = &md.SmallPublicPlatoonRelateCommissionResp{
			PendingAmount:      param.PendingAmount,
			Oid:                param.Oid,
			SelfRateList:       selfRateList,
			CommonWealthSystem: commonWealthSystem,
			DirectPush:         directPush,
		}
	}
	return resp, nil
}

func BatchSmallGetPublicPlatoonRelateCommissionLevel(engine *xorm.Engine, masterId string, PublicPlatoonRelateCommissionReqList []*md.SmallPublicPlatoonRelateCommissionReq) (map[string]*md.SmallPublicPlatoonRelateCommissionResp, error) {
	var resp = make(map[string]*md.SmallPublicPlatoonRelateCommissionResp)
	for _, param := range PublicPlatoonRelateCommissionReqList {
		// 根据供应商
		rewardOpt, err := db.DbsPlanRewardByPvd(engine, param.Pvd)
		if err != nil {
			return nil, err
		}
		if rewardOpt == nil {
			return nil, zhios_order_relate_logx.Warn("找不到方案记录")
		}
		if rewardOpt.State == 0 {
			return nil, zhios_order_relate_logx.Warn("抽成方案未开启")
		}
		if rewardOpt.PlanCommissionId == 0 {
			return nil, zhios_order_relate_logx.Warn("抽成方案未设置佣金方案id")
		}
		fmt.Println("抽成设置:", zhios_order_relate_utils.SerializeStr(rewardOpt))
		fmt.Println("commission id:", rewardOpt.PlanCommissionId)

		//TODO::计算共富收益
		commissionOpt, err := db.DbsPlanCommissionById(engine, rewardOpt.PlanCommissionId)
		if err != nil || commissionOpt == nil || commissionOpt.Id == 0 {
			return nil, err
		}
		var subsidyTmp = make(map[string]*md.LvGrade)
		var tmp map[string]*md.LvGrade
		if err := json.Unmarshal([]byte(commissionOpt.Data), &tmp); err != nil {
			return nil, zhios_order_relate_logx.Warn(fmt.Sprintf("%s:分佣方案数据设置错误", masterId))
		}
		for _, v := range tmp {
			subsidyTmp[zhios_order_relate_utils.IntToStr(v.Lv)] = v
		}
		var directPush = make(map[string]string)
		var selfRateList = make(map[string]string)
		var commonWealthSystem = make(map[string]string)
		lvGrade := subsidyTmp[param.UserLevel]
		if lvGrade != nil {
			for _, coinId := range lvGrade.ReturnType {
				var pendingAmount = param.PendingAmount
				if zhios_order_relate_utils.StrToInt(coinId) > 0 { //积分更换基数
					pendingAmount = param.PendingIntegral
				}
				selfRateList[coinId] = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(lvGrade.SelfRateList[coinId])*zhios_order_relate_utils.StrToFloat64(pendingAmount)/100, 9)
			}
		}
		//TODO::本次消费产生的共富收益给到谁
		nowBenefitUid, _, err := benefitUid(engine, param)
		if err != nil {
			return nil, err
		}
		recommendUid := ""
		userProfile, _ := db.UserProfileFindByID(engine, param.Uid)
		if userProfile != nil && userProfile.ParentUid > 0 {
			recommendUid = zhios_order_relate_utils.IntToStr(userProfile.ParentUid)
		}
		//直推獎勵
		if zhios_order_relate_utils.StrToInt(recommendUid) > 0 {
			parentUid, _ := db.UserFindByID(engine, recommendUid)
			lvGrade := subsidyTmp[zhios_order_relate_utils.IntToStr(parentUid.Level)]
			if lvGrade != nil {
				for _, coinId := range lvGrade.ReturnType {
					var pendingAmount = param.PendingAmount
					if zhios_order_relate_utils.StrToInt(coinId) > 0 { //积分更换基数
						pendingAmount = param.PendingIntegral
					}
					directPush[coinId] = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(lvGrade.DirectPush[coinId])*zhios_order_relate_utils.StrToFloat64(pendingAmount)/100, 9)
				}
			}
		}
		//共富简历
		if zhios_order_relate_utils.StrToInt(nowBenefitUid) > 0 {
			parentUid, _ := db.UserFindByID(engine, nowBenefitUid)
			if parentUid != nil {
				lvGrade := subsidyTmp[zhios_order_relate_utils.IntToStr(parentUid.Level)]
				if lvGrade != nil {
					//判断购买人是哪个等级
					UserLvUpPublicPlatoonList := make(map[string]interface{})
					if len(lvGrade.UserLvUpPublicPlatoonList) > 0 {
						for _, v1 := range lvGrade.UserLvUpPublicPlatoonList {
							v2 := v1.(map[string]interface{})
							if zhios_order_relate_utils.AnyToInt64(v2["lv"]) == zhios_order_relate_utils.StrToInt64(param.UserLevel) {
								rateList, ok := v2["rate_list"].(map[string]interface{})
								if ok {
									UserLvUpPublicPlatoonList = rateList
								} else {
									rateList, ok := v2["rate_list"].([]interface{})
									if ok {
										for k, v := range rateList {
											UserLvUpPublicPlatoonList[zhios_order_relate_utils.AnyToString(k)] = v
										}
									}
								}
							}
						}
					}
					for _, coinId := range lvGrade.ReturnType {
						var pendingAmount = param.PendingAmount
						if zhios_order_relate_utils.StrToInt(coinId) > 0 { //积分更换基数
							pendingAmount = param.PendingIntegral
						}
						bili := lvGrade.CommonWealthSystem[coinId]
						//判断购买人是哪个等级 读对应的比例
						if UserLvUpPublicPlatoonList != nil {
							newBili, ok := UserLvUpPublicPlatoonList[coinId]
							if ok {
								bili = zhios_order_relate_utils.AnyToString(newBili)
							}
						}
						commonWealthSystem[coinId] = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(bili)*zhios_order_relate_utils.StrToFloat64(pendingAmount)/100, 9)
					}
				}
			}

		}

		resp[param.Oid] = &md.SmallPublicPlatoonRelateCommissionResp{
			Uid:                    param.Uid,
			CommonWealthBenefitUid: nowBenefitUid,
			DirectPushBenefitUid:   recommendUid,
			PendingAmount:          param.PendingAmount,
			Oid:                    param.Oid,
			SelfRateList:           selfRateList,
			CommonWealthSystem:     commonWealthSystem,
			DirectPush:             directPush,
		}
	}
	return resp, nil
}
