package svc

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	"errors"
	"github.com/jinzhu/copier"
	"time"
	"xorm.io/xorm"
)

func AddBonusOrd(engine *xorm.Engine, t *md.BonusOrdParam) error {

	//获取分红基础设置
	pool, err := db.GetCapitalPool(engine)
	if err != nil || pool.Id == 0 {
		return errors.New("分红设置有误")
	}
	if pool.IsUse == 0 {
		return errors.New("功能没有开始使用，插入分红失败")
	}
	var capitalPoolOrd model.CapitalPoolAgentOrd
	copier.Copy(&capitalPoolOrd, &t)
	capitalPoolOrd.Uid = zhios_order_relate_utils.StrToInt(t.Uid)
	capitalPoolOrd.OrdId = zhios_order_relate_utils.AnyToInt64(t.OrdId)
	capitalPoolOrd.CreateAt = time.Now()
	capitalPoolOrd.UpdateAt = time.Now()
	capitalPoolOrd.SettleCardinality = pool.SettleCardinality
	if pool.SettleCardinality == "price" { //价格为基数
		capitalPoolOrd.DepositValue = t.PriceValue
		capitalPoolOrd.Commission = t.PriceValue
	}
	one, err := engine.InsertOne(&capitalPoolOrd)
	if err != nil || one == 0 {
		if err == nil {
			err = errors.New("插入数据有误！")
		}
		return err
	}
	return nil
}
