package svc

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	"errors"
	"fmt"
)

// HandleBalanceDistributedLockForAmount 处理余额更新时获取锁和释放锁 如果加锁成功，使用语句 ` defer cb() ` 释放锁
func HandleBalanceDistributedLockForAmount(masterId, uid, requestIdPrefix string) (cb func(), err error) {
	// 获取余额更新锁
	balanceLockKey := fmt.Sprintf(md.UserFinValidUpdateLock, masterId, uid)
	requestId := GetDistributedLockRequestId(requestIdPrefix)
	balanceLockOk := TryGetDistributedLock(balanceLockKey, requestId, true)
	if !balanceLockOk {
		return nil, errors.New("系统繁忙，请稍后再试")
	}

	cb = func() {
		_, _ = ReleaseDistributedLock(balanceLockKey, requestId)
	}

	return cb, nil
}
